﻿
//Ios webkit WKHashMap对象要放在ajax前面才能正确执行，不知道为什么
var WKHashMap = function()
{  
    //定义长度  
    var length = 0;  
    //创建一个对象  
    var obj = new Object();  
  
    /** 
    * 判断Map是否为空 
    */  
    this.isEmpty = function(){  
        return length == 0;  
    };  
  
    /** 
    * 判断对象中是否包含给定Key 
    */  
    this.containsKey=function(key){  
        return (key in obj);  
    };  
  
    /** 
    * 判断对象中是否包含给定的Value 
    */  
    this.containsValue=function(value){  
        for(var key in obj){  
            if(obj[key] == value){  
                return true;  
            }  
        }  
        return false;  
    };  
  
    /** 
    *向map中添加数据 
    */  
    this.put=function(key,value){  
        if(!this.containsKey(key)){  
            length++;  
        }  
        obj[key] = value;  
    };  
  
    /** 
    * 根据给定的Key获得Value 
    */  
    this.get=function(key){  
        return this.containsKey(key)?obj[key]:null;  
    };  
  
    /** 
    * 根据给定的Key删除一个值 
    */  
    this.remove=function(key){  
        if(this.containsKey(key)&&(delete obj[key])){  
            length--;  
        }  
    };  
  
    /** 
    * 获得Map中的所有Value 
    */  
    this.values=function(){  
        var _values= new Array();  
        for(var key in obj){  
            _values.push(obj[key]);  
        }  
        return _values;  
    };  
  
    /** 
    * 获得Map中的所有Key 
    */  
    this.keySet=function(){  
        var _keys = new Array();  
        for(var key in obj){  
            _keys.push(key);  
        }  
        return _keys;  
    };  
  
    /** 
    * 获得Map的长度 
    */  
    this.size = function(){  
        return length;  
    };  
  
    /** 
    * 清空Map 
    */  
    this.clear = function(){  
        length = 0;  
        obj = new Object();  
    };  
} 


//数据库对象
var webkitobjectid = 0;

var DB = function()
{
	 this.id= webkitobjectid++;
	 this.objName = "db";
	 this.dbName = "";
	 this.dbPath = "";
	 this.open = function(dbName,path)
	 {
	 		 var count = arguments.length
	 		 if(count == 1)
	 		 {
	 		 	 path = "";
	 		 }
	  	 this.dbName = dbName;
	  	 this.dbPath = path;
	  	 //Log.i("DB","open name=" + dbName + " path=" + path + " id=" + this.id + " arguments.length=" + arguments.length);
	  	 var text = Bridge.callRetStr('s_DB_open',this.id,this.dbName,this.dbPath, null, null,null,null);
	  	 return stringToBool(text);
	 };
	 this.isOpen = function()
	 {
	 		var text = Bridge.callRetStr('s_DB_isopen',this.id,this.dbName,this.dbPath, null, null,null,null);	 		
	 		return stringToBool(text);
	 };	
	 this.close = function()
	 {
	 		var text = Bridge.callRetStr('s_DB_close',this.id,this.dbName,this.dbPath, null, null,null,null);
	 		return stringToBool(text);
	 };
	 this.createTable = function(tableName,args)
	 {
	 	  var json = arrayToJsonString(args);	 		
	 		var text = Bridge.callRetStr('s_DB_createTable',this.id,tableName,json, null, null,null,null);
	 		return stringToBool(text);
	 };	
	 this.dropTable = function(tableName)
	 {	 	  
	 		var text = Bridge.callRetStr('s_DB_dropTable',this.id,tableName,null, null, null,null,null);
	 		return stringToBool(text);
	 };	
	 this.isTableExist = function(tableName)
	 {
	 		var text = Bridge.callRetStr('s_DB_isTableExist',this.id,tableName,null, null, null,null,null);
	 		return stringToBool(text);
	 };	
	 this.getTableCols = function(tableName)
	 {
	 		var text = Bridge.callRetStr('s_DB_getTableCols',this.id,tableName,null, null, null,null,null);
	 		return jsonStringToArray(text);
	 };	
	 this.addCol = function(tableName, colName, colType, colDefaultvalue)
	 {
	 		var count = arguments.length
	 		if(count == 3)
	 		{
	 			 colDefaultvalue = "";
	 		}
	 		var text = Bridge.callRetStr('s_DB_addCol',this.id,tableName,colName, colType, colDefaultvalue,null,null);
	 		return stringToBool(text);
	 };	 
	 this.query = function(sql)
	 {
	 		var text = Bridge.callRetStr('s_DB_query',this.id,sql,null, null, null,null,null);
	 		var json = ExmobiJSON.parse(text);
	 		return json; 		
	 }
	 this.execute = function(sql)
	 {
	 		var text = Bridge.callRetStr('s_DB_execute',this.id,sql,null, null, null,null,null);
	 		return stringToBool(text);
	 };
	 this.executes = function(sqls)
	 {
	 	  var text = arrayToJsonString(sqls);
	 		var res = Bridge.callRetStr('s_DB_executes',this.id,text,null, null, null,null,null);
	 		return stringToBool(res);
	 };
	 this.transaction = function(sqls)
	 {
	 	  var text = arrayToJsonString(sqls);
	 		var res = Bridge.callRetStr('s_DB_transaction',this.id,text,null, null, null,null,null);
	 		return stringToBool(res);
	 };
	 this.insert = function(tabName,colNames,colValues)
	 {	 	  
	 	  var text = arrayToJsonString(colNames);
	 	  var text1 = arrayToJsonString(colValues);
	 		var res = Bridge.callRetStr('s_DB_insert',this.id,tabName,text, text1, null,null,null);
	 		return stringToBool(res);
	 };	 
	 this.update = function(tabName, colNames, colValues, optionColNames,optionColValues)
	 {
	 	  var text1 = arrayToJsonString(colNames);
	 	  var text2 = arrayToJsonString(colValues);
	 	  var text3 = arrayToJsonString(optionColNames);
	 	  var text4 = arrayToJsonString(optionColValues);
	 		var res = Bridge.callRetStr('s_DB_update',this.id,tabName,text1, text2, text3,text4,null);
	 		return stringToBool(res);
	 };
	 this.deleteData = function(tabName, optionColNames,optionColValues)
	 {	 	 
	 	  var text1 = arrayToJsonString(optionColNames);
	 	  var text2 = arrayToJsonString(optionColValues);
	 		var res = Bridge.callRetStr('s_DB_deleteData',this.id,tabName,text1, text2, null,null,null);
	 		return stringToBool(res);
	 };
}


//编/解码类工具类
var EncryptionUtil={};
EncryptionUtil.aesbase64Encode = function(input,key)
{
	 return Bridge.callRetStr('s_EncryptionUtil_aesbase64Encode' ,input, key, null, null, null,null,null);
};
EncryptionUtil.base64aesDecode = function(input,key)
{
	 return Bridge.callRetStr('s_EncryptionUtil_base64aesDecode' ,input, key, null, null, null,null,null);
};
EncryptionUtil.aesFileDecode = function(srcPath,dstPath,key){
	 Bridge.callRetStr('s_EncryptionUtil_aesFileDecode' ,srcPath,dstPath,key, null, null,null,null);
};
EncryptionUtil.aesFileEncode = function(srcPath,dstPath,key){
	 Bridge.callRetStr('s_EncryptionUtil_aesFileEncode' ,srcPath,dstPath,key, null, null,null,null);
};
EncryptionUtil.base64Decode  = function(src){
	 return Bridge.callRetStr('s_EncryptionUtil_base64Decode' ,src, null, null, null, null,null,null);
};
EncryptionUtil.base64Encode  = function(src){
	 return Bridge.callRetStr('s_EncryptionUtil_base64Encode' ,src, null, null, null, null,null,null);
};
EncryptionUtil.createQrImage = function(content,savePath,size,successCallFun,errorCallFun,isShowWhite)
{
	 Bridge.callByNotify(createQrImageCallBackSuccess,successCallFun,createQrImageCallBackFail,errorCallFun,null,'s_EncryptionUtil_createQrImage',content,savePath,size,isShowWhite, null, null,null);
	
};
EncryptionUtil.xmlToJson  = function(xml){
	 var text = Bridge.callRetStr('s_EncryptionUtil_xmlToJson',xml, null, null, null, null,null,null);
	if(text == "null")
	  return null;
	if(text == "")
	  return null;
	 var jsonStr = ExmobiJSON.parse(text);
	 return jsonStr;
};

EncryptionUtil.escapeXml  = function(src){
	 return Bridge.callRetStr('s_EncryptionUtil_escapeXml' ,src, null, null, null, null,null,null);
};
EncryptionUtil.unEscapeXml  = function(src){
	 return Bridge.callRetStr('s_EncryptionUtil_unEscapeXml' ,src, null, null, null, null,null,null);
};
EncryptionUtil.base64ToImage  = function(data,imagePath){
	 return Bridge.callRetStr('s_EncryptionUtil_base64ToImage' ,data, imagePath, null, null, null,null,null);
};
EncryptionUtil.imageToBase64  = function(imagePath){
	 return Bridge.callRetStr('s_EncryptionUtil_imageToBase64' ,imagePath, null, null, null, null,null,null);
};
function createQrImageCallBackSuccess(id,path)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(path);
}
function createQrImageCallBackFail(id,path)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback2(path);
}

EncryptionUtil.md5  = function(src){
	 return Bridge.callRetStr('s_EncryptionUtil_md5' ,src, null, null, null, null,null,null);
};
EncryptionUtil.urlEncode = function(src,encodeType){
	 return Bridge.callRetStr('s_EncryptionUtil_urlEncode' ,src, encodeType, null, null, null,null,null);
};
EncryptionUtil.base64ToImage = function(json)
{
	 var text =	JsonObjectToString(json);
	 text = Bridge.callRetStr('s_EncryptionUtil_base64ToImage' ,text, null, null, null, null,null,null);
	 return stringToBool(text);
};
EncryptionUtil.imageToBase64 = function(json)
{
	 var text =	JsonObjectToString(json);
	 return Bridge.callRetStr('s_EncryptionUtil_imageToBase64' ,text, null, null, null, null,null,null);	
};

EncryptionUtil.createBarcodeImage = function(json,callback)
{	
	var text = JsonObjectToString(json);
    Bridge.callByNotify(_QqUtil_callBackFun,callback,null,null,this,"s_EncryptionUtil_createBarcodeImage",text, null, null, null, null,null,null); 	
};


//终端设备操作工具类
var DeviceUtil={};
DeviceUtil.startLight = function(){
	 Bridge.callRetStr('s_DeviceUtil_startLight',null,null,null, null, null,null,null);
};
DeviceUtil.closeLight = function(){
	 Bridge.callRetStr('s_DeviceUtil_closeLight',null,null,null, null, null,null,null);
};
DeviceUtil.getEsn = function(){
   return Bridge.callRetStr('s_DeviceUtil_getEsn' ,null, null, null, null, null,null,null);
};
DeviceUtil.getImsi = function(){
   return Bridge.callRetStr('s_DeviceUtil_getImsi' ,null, null, null, null, null,null,null);
};
DeviceUtil.getMac = function(){
   return Bridge.callRetStr('s_DeviceUtil_getMac' ,null, null, null, null, null,null,null);
};
DeviceUtil.getOs = function(){
   return Bridge.callRetStr('s_DeviceUtil_getOs' ,null, null, null, null, null,null,null);
};
DeviceUtil.getOsVersion = function(){
   return Bridge.callRetStr('s_DeviceUtil_getOsVersion' ,null, null, null, null, null,null,null);
};
DeviceUtil.getPhoneModel = function(){
   return Bridge.callRetStr('s_DeviceUtil_getPhoneModel' ,null, null, null, null, null,null,null);
};
DeviceUtil.getScreenHeight = function()
{
   return stringToInt(Bridge.callRetStr('s_DeviceUtil_getScreenHeight' ,null, null, null, null, null,null,null));
};
DeviceUtil.getScreenWidth = function()
{
   return stringToInt(Bridge.callRetStr('s_DeviceUtil_getScreenWidth' ,null, null, null, null, null,null,null));
};
DeviceUtil.getNotifyBarHeight = function()
{
   return stringToInt(Bridge.callRetStr('s_DeviceUtil_getNotifyBarHeight' ,null, null, null, null, null,null,null));
};
DeviceUtil.getLanguage = function(){
   return Bridge.callRetStr('s_DeviceUtil_getLanguage' ,null, null, null, null, null,null,null);
};
DeviceUtil.setVolume = function(dwVolume){
	 Bridge.callRetStr('s_DeviceUtil_setVolume',dwVolume,null,null, null, null,null,null);
};
DeviceUtil.vibrate = function(){
	 Bridge.callRetStr('s_DeviceUtil_vibrate',null,null,null, null, null,null,null);
};
DeviceUtil.getDeviceType = function()
{
	 return Bridge.callRetStr('s_DeviceUtil_getDeviceType',null,null,null, null, null,null,null);
};
DeviceUtil.getAvailableMemory = function()
{
	 var text = Bridge.callRetStr('s_DeviceUtil_getAvailableMemory',null,null,null, null, null,null,null);
	 return stringToDouble(text);
};
DeviceUtil.getDpi = function(){
   return Bridge.callRetStr('s_DeviceUtil_getDpi' ,null, null, null, null, null,null,null);
};

DeviceUtil.getManufacture = function()
{
	 return Bridge.callRetStr('s_DeviceUtil_getManufacture',null,null,null, null, null,null,null);	 
};
DeviceUtil.isSupportBluetooth = function()
{
	 var text = Bridge.callRetStr('s_DeviceUtil_isSupportBluetooth',null,null,null, null, null,null,null);	 
	 return stringToBool(text);
};
DeviceUtil.isSupportWifi = function()
{
	 return true;
};
DeviceUtil.getDeviceToken = function()
{
	 var text = Bridge.callRetStr('s_DeviceUtil_getDeviceToken',null,null,null, null, null,null,null);		
	 if(text == "null")
	    return null;
	 else
	    return text;
};
DeviceUtil.getMobileOperatorName = function()
{
	var text = Bridge.callRetStr('s_DeviceUtil_getMobileOperatorName',null,null,null, null, null,null,null);	
     if(text == "null")
	    return null;
	 else
	    return text;	
};
DeviceUtil.getSimSerialNumber = function()
{
	var text = Bridge.callRetStr('s_DeviceUtil_getSimSerialNumber',null,null,null, null, null,null,null);	
     if(text == "null")
	    return null;
	 else
	    return text;	
};

DeviceUtil.addNotification = function(jsonData)
{
    var text = JsonObjectToString(jsonData);
	return Bridge.callRetStr('s_DeviceUtil_addNotification',text,null,null, null, null,null,null);	    
};

DeviceUtil.clearNotification = function(notificationId)
{    
	return Bridge.callRetStr('s_DeviceUtil_clearNotification',notificationId,null,null, null, null,null,null);	    
};
DeviceUtil.clearNotifications = function()
{    
	return Bridge.callRetStr('s_DeviceUtil_clearNotifications',null,null,null, null, null,null,null);	    
};
DeviceUtil.screenClip = function(jsonData,callbackFun)
{    
	var jsontext = JsonObjectToString(jsonData);
	Bridge.callByNotify(_DeviceUtil_ScreenClipCallBack,callbackFun,null,null,null,'s_DeviceUtil_screenClip',jsontext,null,null, null, null,null,null);	  
};
DeviceUtil.setKeepScreenOn = function()
{    
	Bridge.callRetStr('s_DeviceUtil_setKeepScreenOn',null,null,null, null, null,null,null);	  
};
DeviceUtil.clearKeepScreenOn = function()
{    
	Bridge.callRetStr('s_DeviceUtil_clearKeepScreenOn',null,null,null, null, null,null,null);	  
};
DeviceUtil.isKeepScreenOn = function()
{    
	var text = Bridge.callRetStr('s_DeviceUtil_isKeepScreenOn',null,null,null, null, null,null,null);	
	return stringToBool(text);
};

function _DeviceUtil_ScreenClipCallBack(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
    	var json = JSON.parse(text);
        callback.usercallback1(json);
    }
}

//短信工具类
var SmsUtil={};
SmsUtil.openSystemSms = function(phone,content){
	 Bridge.callRetStr('s_SmsUtil_openSystemSms',phone,content,null, null, null,null,null);
};
SmsUtil.sendSms = function(phone,content){
	 Bridge.callRetStr('s_SmsUtil_sendSms',phone,content,null, null, null,null,null);
};
//电话工具类
var PhoneUtil={};	
PhoneUtil.openSystemDial = function(phone){
	 Bridge.callRetStr('s_PhoneUtil_openSystemDial',phone,null,null, null, null,null,null);
};
PhoneUtil.tel = function(phone){
	 Bridge.callRetStr('s_PhoneUtil_tel',phone,null,null, null, null,null,null);
};
PhoneUtil.getCallRecords = function(callType)
{
	 if(arguments.length == 0)
	 {
	 	 callType = null;
	 }
   var str = Bridge.callRetStr('s_PhoneUtil_getCallRecords' ,callType, null, null, null, null,null,null);
   return ExmobiJSON.parse(str);
};	

PhoneUtil.faceTime = function(faceTimeNum)
{
	 Bridge.callRetStr('s_PhoneUtil_faceTime',faceTimeNum,null,null, null, null,null,null);
};

//文件操作工具类
var FileUtil={};
FileUtil.deleteFolder = function(dir)
{
   return stringToBool(Bridge.callRetStr('s_FileUtil_deleteFolder' ,dir, null, null, null, null,null,null));
};
FileUtil.readFile = function(filePath){
   return Bridge.callRetStr('s_FileUtil_readFile' ,filePath, null, null, null, null,null,null);
};	
FileUtil.writeFile = function(filePath,content,mode)
{
   return stringToBool(Bridge.callRetStr('s_FileUtil_writeFile' ,filePath,content,mode, null, null,null,null));
};
FileUtil.unZip = function(zipFilePath,folderFilePath,unzipCallBack,pwd){
var count = arguments.length;
if(count==3)
{
	Bridge.callByNotify(_unzipCallBack,unzipCallBack,null,null,null,'s_FileUtil_unZip',zipFilePath,folderFilePath,"", null, null,null,null);
}else if(count==4)
{
	Bridge.callByNotify(_unzipCallBack,unzipCallBack,null,null,null,'s_FileUtil_unZip',zipFilePath,folderFilePath,pwd, null, null,null,null);
}
    
};	
function _unzipCallBack(id,result,path){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(result,path);
}

//压缩文件 支持文件或文件夹
FileUtil.zip = function(folderFilePath,zipFilePath,zipCallBack,pwd){
var count = arguments.length;
if(count==3)
{
	Bridge.callByNotify(_zipCallBack,zipCallBack,null,null,null,'s_FileUtil_zip', folderFilePath, zipFilePath, "",null,null,null,null);
}else if(count==4)
{
	Bridge.callByNotify(_zipCallBack,zipCallBack,null,null,null,'s_FileUtil_zip', folderFilePath, zipFilePath, pwd,null,null,null,null);
}
		
};
//压缩文件回调函数
function _zipCallBack(id,result,path){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(result,path);
}
//定位操作工具类
var GpsUtil = {};
GpsUtil.getCellIdInfo = function()
{
   var str = Bridge.callRetStr('s_GpsUtil_getCellIdInfo' ,null, null, null,null,null,null,null);
   return ExmobiJSON.parse(str);
};
GpsUtil.getGpsState = function()
{
   return stringToBool(Bridge.callRetStr('s_GpsUtil_getGpsState' ,null, null, null,null,null,null,null));
};
GpsUtil.getNetGpsState = function()
{
   return stringToBool(Bridge.callRetStr('s_GpsUtil_getNetGpsState' ,null, null, null,null,null,null,null));
};
GpsUtil.startGpsSetting = function()
{
   Bridge.callRetStr('s_GpsUtil_startGpsSetting' ,null, null, null,null,null,null,null);
};
//基座相关工具类
var ClientUtil = {};

ClientUtil.exit = function(content){
	 Bridge.callRetStr('s_ClientUtil_exit' ,content, null, null,null,null,null,null);
};
ClientUtil.exitNoAsk = function(){
	 Bridge.callRetStr('s_ClientUtil_exitNoAsk' ,null, null, null,null,null,null,null);
};
ClientUtil.getBadgeNumber = function(){
	 return stringToInt(Bridge.callRetStr('s_ClientUtil_getBadgeNumber' ,null, null, null,null,null,null,null));
};
ClientUtil.setBadgeNumber = function(number){
	 Bridge.callRetStr('s_ClientUtil_setBadgeNumber' ,number, null, null,null,null,null,null);
};
ClientUtil.getClientId = function(){
	 return Bridge.callRetStr('s_ClientUtil_getClientId' ,null, null, null,null,null,null,null);
};
ClientUtil.getRegister = function()
{
   var str = Bridge.callRetStr('s_ClientUtil_getRegister' ,null, null, null,null,null,null,null);
   var jsonObj = ExmobiJSON.parse(str);  
   var register = new RegisterInfo();
   register.objName = jsonObj.objName;
   register.phone = jsonObj.phone;
   register.username = jsonObj.username;
   register.ec = jsonObj.ec;
   return register;
};
ClientUtil.setRegister = function(registerInfo,successFun,errorFun)
{
    var register = '{'+'"objName":"'+registerInfo.objName+'"'+',"phone":"'+registerInfo.phone+'"'+',"username":"'+registerInfo.username+'"'+',"ec":"'+registerInfo.ec+'"'+'}';
    //Log.i("setRegister",register);
    if(arguments.length == 3)
	  {
	  	
	  }
	  else  if(arguments.length == 2)
	  {
	  	 errorFun = null;
	  }
	  else
	  {
	  	 successFun = null;
	  	 errorFun = null;
	  }	 
	  var isHasSuccessFun = false;
	  if(successFun != null)
	  	isHasSuccessFun = true;
	  var isHasFailFun = false;
	  if(errorFun != null)
	  	isHasFailFun = true;	  
	 	Bridge.callByNotify(WebkitSetRegisterSuccessCallBack,successFun,WebkitSetRegisterFailCallBack,errorFun,null,'s_ClientUtil_setRegister' ,register, isHasSuccessFun, isHasFailFun,null,null,null,null);
};
function RegisterInfo() 
{
	this.objName = "registerinfo";
  this.phone = "";
  this.username = "";
	this.ec = "";  
}
function WebkitSetRegisterSuccessCallBack(id,text)
{
	  var json = ExmobiJSON.parse(text);	 		
		var callback = Bridge.callbacks[id];
		if(callback.usercallback1)
		{
			 callback.usercallback1(json);
		}		
}
function WebkitSetRegisterFailCallBack(id,text)
{
	  var json = ExmobiJSON.parse(text);
		//获取回调对象
		var callback = Bridge.callbacks[id];
		if(callback.usercallback2)
		{
			callback.usercallback2(json);
		}
}
ClientUtil.getSetting = function()
{
   var str =  Bridge.callRetStr('s_ClientUtil_getSetting' ,null, null, null, null, null,null,null);
   var jsonObj = ExmobiJSON.parse(str);
   var setting = new SettingInfo();
   setting.objName = jsonObj.objName;
   setting.ip = jsonObj.ip;
   setting.port = jsonObj.port;
   setting.sslport = jsonObj.sslport;
   setting.isssl = jsonObj.isssl;
   setting.cachetime = jsonObj.cachetime;
   setting.ispushopen = jsonObj.ispushopen;
   return setting;
};
ClientUtil.saveSetting = function(settingInfo)
{
   var setting = '{'+'"objName":"'+settingInfo.objName+'"'+',"ip":"'+settingInfo.ip+'"'+',"port":"'+settingInfo.port+'"'+',"sslport":"'+settingInfo.sslport+'"'+',"isssl":"'+settingInfo.isssl+'"'+',"cachetime":"'+settingInfo.cachetime+'"'+',"ispushopen":"'+settingInfo.ispushopen+'"'+'}';
	 Bridge.callRetStr('s_ClientUtil_saveSetting' ,setting, null, null,null,null,null,null);
};
function SettingInfo() 
{
	var str =  Bridge.callRetStr('s_ClientUtil_getSetting' ,null, null, null, null, null,null,null);
  var jsonObj = ExmobiJSON.parse(str);
	this.objName = jsonObj.objName;
  this.ip = jsonObj.ip;
  this.port = jsonObj.port;
  this.sslport = jsonObj.sslport;
  this.isssl = jsonObj.isssl;
  this.cachetime = jsonObj.cachetime;
  this.ispushopen = jsonObj.ispushopen;	  
}
ClientUtil.getVersion = function(){
	 return Bridge.callRetStr('s_ClientUtil_getVersion' ,null, null, null,null,null,null,null);
};
ClientUtil.shareClientToFriends = function(){
	 Bridge.callRetStr('s_ClientUtil_shareClientToFriends' ,null, null, null,null,null,null,null);
};
ClientUtil.startClientUpdate = function(onCallBack){
	Bridge.callByNotify(WebkitstartClientUpdateCallBack,onCallBack,null,null,null,'s_ClientUtil_startClientUpdate' ,null, null, null,null,null,null,null);
};
function WebkitstartClientUpdateCallBack(id,code)
{		
	var callback = Bridge.callbacks[id];
	if(callback.usercallback1)	
	{
	   callback.usercallback1(code);
	}
}		

ClientUtil.startAppUpdate = function(){
	 Bridge.callRetStr('s_ClientUtil_startAppUpdate' ,null, null, null,null,null,null,null);
};
ClientUtil.cleanCache = function()
{
	 return stringToBool(Bridge.callRetStr('s_ClientUtil_cleanCache' ,null, null, null,null,null,null,null));
};
ClientUtil.execScript = function(script)
{
	 Bridge.callRetStr('s_ClientUtil_execScript' ,script, null, null,null,null,null,null);
};
ClientUtil.openAdminSelectedAppUI = function(){
	 Bridge.callRetStr('s_ClientUtil_openAdminSelectedAppUI' ,null, null, null,null,null,null,null);
};
ClientUtil.openApp = function(appid,parameterInfos)
{
      var text = "[";
      var len = 0;
      if(parameterInfos != null)
      {
	 len = parameterInfos.length;
	 
	 for(var i = 0; i < len ; i++)
	 {
	 	  var o = parameterInfos[i];
	 	  text = text + '{\"key\":\"' + o.key + '\",';
	 	   text = text + '\"value\":\"' + o.value + '\"}';
	 	  if(i != len - 1)
	 	  {
	 	  	 text = text + ",";
	 	  }
	 }
	 text = text + "]";	
	 }
	 else
	 {
	 text = null;
	 }
	 Bridge.callRetStr('s_ClientUtil_openApp' ,appid, text, null,null,null,null,null);
};
ClientUtil.random = function(start,end)
{
	 return stringToInt(Bridge.callRetStr('s_ClientUtil_random' ,start,end, null,null,null,null,null));
};
ClientUtil.clearDownload = function()
{
	 return stringToBool(Bridge.callRetStr('s_ClientUtil_clearDownload' ,null,null, null,null,null,null,null));
};
ClientUtil.download = function(url,dstpath, successCallFun,errorCallFun,isblock)
{
	 if(arguments.length == 5)
	 {
	 	  //五个参数全齐
	 }
	 else if(arguments.length == 4)
	 {
	 	 	 	  isblock = true;
	 }
	 else if(arguments.length == 3)
	 {
	 	 	 	  isblock = true;
	 	  errorCallFun = null;
	 }
	 else if(arguments.length == 2)
	 {
	 	 	 	  isblock = true;
	 	 errorCallFun = null;
	 	 successCallFun = null;
	 }
	 else if(arguments.length == 1)
	 {
	 		 	  isblock = true;
	 	 errorCallFun = null;
	 	 successCallFun = null;
	 	 dstpath = null;
	 }	 
	 Bridge.callByNotify(WebkitDownloadSuccessCallBack,successCallFun,WebkitDownloadErrorCallBack,errorCallFun,null,'s_ClientUtil_download' ,url, dstpath, isblock,null,null,null,null);
};
function WebkitDownloadSuccessCallBack(id,path)
{		
		var callback = Bridge.callbacks[id];
		if(callback.usercallback1)	
		{
			callback.usercallback1(path);	
		}		
}
function WebkitDownloadErrorCallBack(id,path)
{		
		var callback = Bridge.callbacks[id];
		if(callback.usercallback2)	
		{
			callback.usercallback2(path);
		}		
}
ClientUtil.getDownloadInfos = function(downloadType)
{
	 if(arguments.length == 0)
	 {
	 	 downloadType = "0";
	 }
   var str = Bridge.callRetStr('s_ClientUtil_getDownloadInfos' ,downloadType, null, null,null,null,null,null);
   return ExmobiJSON.parse(str);
};
ClientUtil.getAppId = function(){
	 return Bridge.callRetStr('s_ClientUtil_getAppId' ,null,null, null,null,null,null,null);
};
ClientUtil.getApplicationInfos = function()
{
   var str = Bridge.callRetStr('s_ClientUtil_getApplicationInfos' ,null, null, null,null,null,null,null);
   return ExmobiJSON.parse(str);
};
ClientUtil.getApplicationInfo = function(appid)
{
    var str = Bridge.callRetStr('s_ClientUtil_getApplicationInfo',appid, null, null,null,null,null,null);
    return ExmobiJSON.parse(str);
};
ClientUtil.setupApp = function(appid,path)
{
        Bridge.callRetStr('s_ClientUtil_setupApp',appid, path, null,null,null,null,null);
};
ClientUtil.getAppPath = function(){
	 return Bridge.callRetStr('s_ClientUtil_getAppPath' ,null,null, null,null,null,null,null);
};
ClientUtil.getDB = function(appid)
{
	 var id = webkitobjectid;
   var str = Bridge.callRetStr('s_ClientUtil_getDB' ,appid, id, null,null,null,null,null);
   var b = stringToBool(str);
   if(b)
   {
   		//创建新的db,db的id会在构造函数中自增 并且等于 id
   		var db = new DB();
   		return db;
   }
   else
   {
   	  return null;
   }  
};

ClientUtil.hideSip = function()
{
	Bridge.callRetStr('s_ClientUtil_hideSip' ,null, null, null,null,null,null,null);
};
ClientUtil.getAbsolutePath = function(path)
{
	return Bridge.callRetStr('s_ClientUtil_getAbsolutePath' ,path, null, null,null,null,null,null);
};
ClientUtil.setCdf = function(cdf)
{
	var text = Bridge.callRetStr('s_ClientUtil_setCdf' ,cdf, null, null,null,null,null,null);	
	return stringToBool(text);
};
ClientUtil.getCdf = function(cdf)
{
	return Bridge.callRetStr('s_ClientUtil_getCdf' ,null, null, null,null,null,null,null);		
};
ClientUtil.openImageList = function(jsonData)
{
    var jsontext = JsonObjectToString(jsonData);
	return Bridge.callRetStr('s_ClientUtil_openImageList' ,jsontext, null, null,null,null,null,null);		
};

ClientUtil.changeToBackground = function(jsonData)
{
    Bridge.callRetStr('s_ClientUtil_changeToBackground' ,null, null, null,null,null,null,null);	
};
ClientUtil.jsonToString = function(json)
{
	var jsontext = JsonObjectToString(json);
	return jsontext;	
};

ClientUtil.stringToJson = function(json)
{
    return exmobiStringToJson(json);	
};
function exmobiStringToJson(o)
{  
	try{
		return eval("("+o+")");	
	}catch(e)
	{
	 return null;
	}
	   
}
//PageUtil类相关
var PageUtil = {};
PageUtil.getTitleHeight = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getTitleHeight' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};

PageUtil.getHeaderHeight = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getHeaderHeight' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};
PageUtil.getBodyHeight = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getBodyHeight' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};
PageUtil.getFooterHeight = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getFooterHeight' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};
PageUtil.getWindowHeight = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getWindowHeight' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};
PageUtil.getWindowWidth = function()
{
	var text =  Bridge.callRetStr('s_PageUtil_getWindowWidth' ,null, null, null,null,null,null,null);	
    return stringToInt(text);	
};
PageUtil.getScreenOrientation = function()
{
	return  Bridge.callRetStr('s_PageUtil_getScreenOrientation' ,null, null, null,null,null,null,null);	   	
};
PageUtil.goHtmlPageById = function(id)
{
	return  Bridge.callRetStr('s_PageUtil_goHtmlPageById' ,id, null, null,null,null,null,null);	   	
};

//多媒体操作工具类
var MediaUtil = {};
MediaUtil.beep = function(audioPath){
	if(arguments.length==0)
	{
	Bridge.callRetStr('s_MediaUtil_beep',null, null, null,null,null,null,null);
	}else
	{
	Bridge.callRetStr('s_MediaUtil_beep',audioPath, null, null,null,null,null,null);
	}
	
}
MediaUtil.openVideo = function(path){
	Bridge.callRetStr('s_MediaUtil_openVideo' ,path, null, null,null,null,null,null);
}
MediaUtil.getAudioPlayer = function(){
	var obj = new AudioPlayer();
    return obj;
}
MediaUtil.getRecord = function(){
	var obj = new Record();
    return obj;
}
//音频对象
var AudioPlayer = function()
{
    this.objName = "audioplayer";

    this.start = function(url, isLooping)
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_start',url, isLooping, null, null, null,null,null));
    };
    this.seekTo = function(position)
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_seekTo',position, null, null, null, null,null,null));
    };
    this.pause = function()
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_pause',null, null, null, null, null,null,null));
    };
    this.resume = function()
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_resume',null, null, null, null, null,null,null));
    };
    this.stop = function(position)
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_stop',null, null, null, null, null,null,null));
    };
    this.getDuration = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_getDuration',null, null, null, null, null,null,null));
    };
    this.getStatus = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_getStatus',null, null, null, null, null,null,null));
    };
    this.getCurrentPosition = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_getCurrentPosition',null, null, null, null, null,null,null));
    };
    this.isLooping = function()
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_isLooping',null, null, null, null, null,null,null));
    };
    this.setVolume = function(volume)
    {
        return stringToBool(Bridge.callRetStr('s_AudioPlayer_setVolume',volume, null, null, null, null,null,null));
    };
    this.getVolume = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_getVolume',null, null, null, null, null,null,null));
    };
    this.volumeUp = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_volumeUp',null, null, null, null, null,null,null));
    };
    this.volumeDown = function()
    {
        return stringToInt(Bridge.callRetStr('s_AudioPlayer_volumeDown',null, null, null, null, null,null,null));
    }
}

var currentRecord;

//录音对象
var Record = function()
{
    this.objName = "record";
    this.value = "";
    this.recordtime = 0;
    this.path = "";
    this.maxtime = 0;

    this.startRecord = function()
    {
   		currentRecord = this;
        //初始化
        this.value = "";
        this.recordtime = 0;
        
        //对录音对象进行赋值
        Bridge.callRetStr('s_Record_path',this.path, null, null, null, null,null,null);
        Bridge.callRetStr('s_Record_maxtime',this.maxtime, null, null, null, null,null,null);
        
        //开始录音
        Bridge.callRetStr('s_Record_startRecord',null, null, null, null, null,null,null);
    };
    this.isRecord = function()
    {
        return stringToBool(Bridge.callRetStr('s_Record_isRecord',null, null, null, null, null,null,null));
    };
    this.stopRecord = function()
    {
        Bridge.callRetStr('s_Record_stopRecord',null, null, null, null, null,null,null);
        
        //结束录音时候，同时把录音时间、音频文件路径信息保存下来
        this.value = Bridge.callRetStr('s_Record_value',null, null, null, null, null,null,null);
        this.recordtime = stringToInt(Bridge.callRetStr('s_Record_recordtime',null, null, null, null, null,null,null));
    };
}

//微信对象WeixinInfo
var WeixinInfo = function()
{
    this.objName = "WeixinInfo";
    this.type = 0;
    this.textcallback = null;
    this.imagecallback = null;
    this.multipleImageCallback = null;
    this.webPageCallback = null;
    this.result = 0;
    var context = this;

    this.isWeixinInstalled = function()
    {
        return stringToBool(Bridge.callRetStr('s_WeixinInfo_isWeixinInstalled',null, null, null, null, null,null,null));
    };
    this.getAppstoreInstallUrl = function()
    {
        return Bridge.callRetStr('s_WeixinInfo_getAppstoreInstallUrl',null, null, null, null, null,null,null);
    };
    
    this.sendText = function(message)
    {
        this.imagecallback = null;
        this.multipleImageCallback = null;
        this.webPageCallback = null;
        //存储callid与回调函数名
        Bridge.callByNotify(_Weixin_onCallback,null,null,null,context,'s_WeixinInfo_sendText' ,this.type, message, null, null, null, null, null);
    };
    this.sendImage = function(message)
    {
        this.textcallback = null;
        this.multipleImageCallback = null;
        this.webPageCallback = null;
        //存储callid与回调函数名
        Bridge.callByNotify(_Weixin_onCallback,null,null,null,context,'s_WeixinInfo_sendImage' ,this.type, message, null, null, null, null, null);
    };
    this.sendMultipleImage = function(message)
    {
        var jsonString = JsonObjectToString(message);
        this.textcallback = null;
        this.imagecallback = null;
        this.webPageCallback = null;
        //存储callid与回调函数名
        Bridge.callByNotify(_Weixin_onCallback,null,null,null,context,'s_WeixinInfo_sendMultipleImage' ,this.type, jsonString, null, null, null, null, null);
    };
    this.sendWebPage = function(message)
    {
        var jsonString = JsonObjectToString(message);
        this.textcallback = null;
        this.imagecallback = null;
        this.multipleImageCallback = null;
        //存储callid与回调函数名
        Bridge.callByNotify(_Weixin_onCallback,null,null,null,context,'s_WeixinInfo_sendWebPage', this.type, jsonString, null, null, null, null, null);
    };
}
//微信回调
function _Weixin_onCallback(id, result)
{
    //Log.i("Webkit", "bridgeclient is _Weixin_onCallback, result=" + result + ",  callId=" + id);
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var weixin = callback.object;
        weixin.result = result;
        if (weixin.textcallback != null){
            weixin.textcallback(weixin);
        }
        if (weixin.imagecallback != null){
            weixin.imagecallback(weixin);
        }
        if (weixin.multipleImageCallback != null){
            weixin.multipleImageCallback(weixin);
        }
        if (weixin.webPageCallback != null){
            weixin.webPageCallback(weixin);
        }
    }
}

//微博对象WeiboInfo
var weiboobjectid = 0;
var WeiboInfo = function()
{
    this.id = weiboobjectid++;
    this.objName = "weiboinfo";
    this.result = 0;
    this.type = "";
    this.bindcallback = null;
    this.sendcallback = null;
    this.latitude = "";
    this.longitude = "";
    this.content = "";
    this.file = "";
    
    var context = this;
    
    this.isbind = function()
    {
        return stringToBool(Bridge.callRetStr('s_WeiboInfo_isbind',this.id, null, null, null, null,null,null));
    };
    this.bind = function()
    {
        //存储callid与回调函数名
        Bridge.callByNotify(_Weibo_onBindCallback,null,null,null,context,'s_WeiboInfo_bind' ,this.id, this.type, null, null, null, null, null);
    };
    this.clearbind = function()
    {
        Bridge.callRetStr('s_WeiboInfo_clearbind',this.id, null, null, null, null,null,null);
    };
    this.send = function()
    {
        //存储callid与回调函数名
        Bridge.callByNotify(_Weibo_onSendCallback,null,null,null,context,'s_WeiboInfo_send' ,this.id, this.content, null, null, null, null, null);
    }
}
//微博回调
function _Weibo_onBindCallback(id, result)
{
    //Log.i("Webkit", "bridgeclient is _Weibo_onBindCallback, result=" + result + ",  callId=" + id);
    var callback = Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var w = callback.object;
        w.result = result;
        if (w.bindcallback != null){
            w.bindcallback(w);
        }
    }
}
function _Weibo_onSendCallback(id, result)
{
    //Log.i("Webkit", "bridgeclient is _Weibo_onSendCallback, result=" + result + ",  callId=" + id);
    var callback = Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var w = callback.object;
        w.result = result;
        if (w.sendcallback != null){
            w.sendcallback(w);
        }
    }
}

//toast对象Toast
var toastobjectid = 0;
var Toast = function()
{
    this.id = toastobjectid++;
    this.objName = "toast";
    var context = this;

    this.setText = function(parameter)
    {
        Bridge.callRetStr('s_Toast_setText',this.id, parameter, null, null, null,null,null);
    };
    this.setDuration = function(parameter)
    {
        //存储callid与回调函数名
        Bridge.callRetStr('s_Toast_setDuration', this.id, parameter, null, null, null, null, null);
    };
    this.show = function()
    {
        Bridge.callRetStr('s_Toast_show', this.id, null, null, null, null,null,null);
    };
    this.setStyle = function(parameter)
    {
        //存储callid与回调函数名
        Bridge.callRetStr('s_Toast_setStyle', this.id, parameter, null, null, null, null, null);
    }
}

//phoneinfo对象PhoneInfo
function PhoneInfo()
{
	this.objName = "phoneinfo";
	this.type = 0;
	this.value = "";
}
function EmailInfo()
{
	this.objName = "emailinfo";
	this.type = 0;
	this.value = "";
}
function GroupInfo()
{
	this.objName = "groupinfo";
	this.id = "";
	this.name = "";
	this.isSystem = false;
}
function Vcard()
{
	this.objName = "vcard";
	this.id = "";
	this.name = "";
	this.surname = "";
	this.lastname = "";
	this.phone = "";
	this.mobile = "";
	this.email = "";
	this.email2 = "";
	this.email3 = "";
	this.address = "";
	this.birthday = "";
	this.company = "";
	this.groupInfo = "";
	this.phones = "";
	this.emails = "";
}

//工具方法：通过json字符串，得到vcards信息
getVcardsByJsonText = function(parameter)
{
    var json = null;
    if(typeof(parameter) == "string")
    {
    
        if("null" != parameter)
        {
            json = ExmobiJSON.parse(parameter);
        }
    }
    else if(typeof(parameter) == "object")
    {
        //Log.i("typeof(parameter)", "object");
        json = parameter;
    }
        if(null == json)
    {
        var emptyArray = new Array();
        return emptyArray;
    }
    
    if(json instanceof Array)
    {
        //Log.i("json instanceof Array", "begin");
        var array = new Array();
        for(var i=0;i<json.length;i++)
        {
            array.push(getVcardsByJsonText(json[i]));
        }
        return array;
        //Log.i("json instanceof Array", "end");
    }
    else
    {
        return getVcardByJson(json);
    }
}
//工具方法：通过json对象，得到vcard对象
getVcardByJson = function(json)
{
    var v = new Vcard();
    if(json.id)
        v.id = json.id;

    if(json.name)
        v.name = json.name;
    
    if(json.lastname)
        v.lastname = json.lastname;
    
    if(json.surname)
        v.surname = json.surname;
    
    if(json.address)
        v.address = json.address;
    
    if(json.birthday)
        v.birthday = json.birthday;
    
    if(json.company)
        v.company = json.company;
    
    if(json.email)
        v.email = json.email;
    
    if(json.email2)
        v.email2 = json.email2;
    
    if(json.email3)
        v.email3 = json.email3;
    
    if(json.phone)
        v.phone = json.phone;
    
    if(json.mobile)
        v.mobile = json.mobile;
    
    if(json.groupInfo)
    {
        v.groupInfo = new GroupInfo();
        v.groupInfo.id = json.groupInfo.id;
        v.groupInfo.name = json.groupInfo.name;
        v.groupInfo.isSystem = json.groupInfo.isSystem;
    }
    
    if(json.phones)
    {
        var arrayPhone = new Array();
        for(var jj = 0; jj < json.phones.length;jj++)
        {
            var temp = new PhoneInfo();
            temp.type = json.phones[jj].type;
            temp.value = json.phones[jj].value;
            arrayPhone.push(temp);
        }
        v.phones = arrayPhone;
    }
    
    if(json.emails)
    {
        var arrayEmail = new Array();
        for(var jj = 0; jj < json.emails.length;jj++)
        {
            var temp = new EmailInfo();
            temp.type = json.emails[jj].type;
            temp.value = json.emails[jj].value;
            arrayEmail.push(temp);
        }
        v.emails = arrayEmail;
    }
    return v;
}
//工具方法：通过vcard对象，得到json数据流
getJsonStringFromVcardObject = function(vcard)
{
    var jsonText = ExmobiJSON.stringifyVcardObject(vcard, ["name", "surname", "lastname", "phone","mobile","email","email2","email3","address","birthday","company","groupInfo","phones","emails","id","objName"]);
    return jsonText;
}
var ContactUtil = {};
/*1*/
ContactUtil.addGroup = function(groupName){
	return Bridge.callRetStr('s_ContactUtil_addGroup',groupName, null, null,null,null,null,null);
}
/*2*/
ContactUtil.addNewVcard = function(vcard,groupId){
    var jsonText = getJsonStringFromVcardObject(vcard);
    //Log.i("addNewVcard is : ",jsonText);

	return Bridge.callRetStr('s_ContactUtil_addNewVcard',jsonText, groupId, null,null,null,null,null);
}
/*3*/
ContactUtil.addVcard = function(vcard,groupId){
    var jsonText = getJsonStringFromVcardObject(vcard);
    //Log.i("addVcard is : ",jsonText);

	return stringToBool(Bridge.callRetStr('s_ContactUtil_addVcard',jsonText, groupId, null,null,null,null,null));
}
/*4*/
ContactUtil.addVcardToGroup = function(groupId,vcardId){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_addVcardToGroup',groupId,vcardId, null,null,null,null,null));
}
/*5*/
ContactUtil.getGroups = function(){
	var res = Bridge.callRetStr('s_ContactUtil_getGroups',null, null, null,null,null,null,null);
    
    if(res == "null")
    {
        return null;
    }
    else
    {
        var json = ExmobiJSON.parse(res);
        
        var arr = new Array();
        for(var i = 0; i < json.length;i++)
        {
            var temp = new GroupInfo();
            temp.name = json[i].name;
            temp.isSystem = json[i].isSystem;
            temp.id = json[i].id;
            
            arr.push(temp);
        }
        return arr;
    }
}
/*6*/
ContactUtil.getNewVcard = function(vcardId){
	var res = Bridge.callRetStr('s_ContactUtil_getNewVcard',vcardId, null, null,null,null,null,null);
    //Log.i("getNewVcard is : ", res);

    return getVcardsByJsonText(res);
}
/*7*/
ContactUtil.getVcard = function(name){
	var res = Bridge.callRetStr('s_ContactUtil_getVcard',name, null, null,null,null,null,null);
    //Log.i("getVcard is : ", res);
    return getVcardsByJsonText(res);
}
/*8*/
ContactUtil.getVcards = function(groupId){
	var res = Bridge.callRetStr('s_ContactUtil_getVcards',groupId, null, null,null,null,null,null);
    //Log.i("getVcards is : ", res);
    
    return getVcardsByJsonText(res);
}
/*9*/
ContactUtil.getVcardsByName = function(name){
	var res = Bridge.callRetStr('s_ContactUtil_getVcardsByName',name, null, null,null,null,null,null);
    //Log.i("getVcardsByName is : ", res);
    return getVcardsByJsonText(res);
}
/*10*/
ContactUtil.getVcardsByPhone = function(phone){
	var res = Bridge.callRetStr('s_ContactUtil_getVcardsByPhone',phone, null, null,null,null,null,null);
    //Log.i("getVcardsByPhone is : ", res);
    return getVcardsByJsonText(res);
}
/*11*/
ContactUtil.openSystemContact = function(){
	Bridge.callRetStr('s_ContactUtil_openSystemContact',null, null, null,null,null,null,null);
}
/*12*/
ContactUtil.removeGroupById = function(groupId){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_removeGroupById',groupId, null, null,null,null,null,null));
}
/*13*/
ContactUtil.removeGroupByName = function(groupName){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_removeGroupByName',groupName, null, null,null,null,null,null));
}
/*14*/
ContactUtil.removeNewVcard = function(vcardId){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_removeNewVcard',vcardId, null, null,null,null,null,null));
}
/*15*/
ContactUtil.removeVcard = function(name){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_removeVcard',name, null, null,null,null,null,null));
}
/*16*/
ContactUtil.removeVcardFromGroup = function(groupId,vcardId){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_removeVcardFromGroup',groupId,vcardId, null,null,null,null,null));
}
/*17*/
ContactUtil.setGroupName = function(groupId,newName){
	return stringToBool(Bridge.callRetStr('s_ContactUtil_setGroupName',groupId,newName, null,null,null,null,null));
}
/*18*/
ContactUtil.setNewVcard = function(vcardId,vcard){
   
    var jsonText = getJsonStringFromVcardObject(vcard);
    //Log.i("setNewVcard is : ",jsonText);
    return Bridge.callRetStr('s_ContactUtil_setNewVcard',vcardId, jsonText, null,null,null,null,null);
}
/*19*/
ContactUtil.setVcard = function(name,vcard){

    var jsonText = getJsonStringFromVcardObject(vcard);
    //Log.i("setVcard is : ",jsonText);

	return stringToBool(Bridge.callRetStr('s_ContactUtil_setVcard',name, jsonText, null,null,null,null,null));
}

ContactUtil.getVcardsAsyn = function(groupId,onCallBack)
{	
    Bridge.callByNotify(_ContactUtil_getVcardsAsyn_callBack,onCallBack,null,null,this,'s_ContactUtil_getVcardsAsyn' ,groupId, null, null, null, null, null, null);
}

ContactUtil.getBasicVcardsAsyn = function(groupId,onCallBack)
{	
    Bridge.callByNotify(_ContactUtil_getVcardsAsyn_callBack,onCallBack,null,null,this,'s_ContactUtil_getBasicVcardsAsyn' ,groupId, null, null, null, null, null, null);
}

function _ContactUtil_getVcardsAsyn_callBack(id,text)
{
	var callback = Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {   
	    var arr = getVcardsByJsonText(text);
        callback.usercallback1(arr); 
    }
}

/*网络工具类*/
var NetworkUtil = {};
//获取apn
NetworkUtil.getApn = function()
{	
   return Bridge.callRetStr('s_NetworkUtil_getApn' ,null, null, null, null, null,null,null);
};
//获取当前网络类型
NetworkUtil.getConnectionType = function()
{
   return stringToInt(Bridge.callRetStr('s_NetworkUtil_getConnectionType', null, null, null, null, null,null,null));
};
//获取当前网络ip地址
NetworkUtil.getNetIp = function()
{	
   return Bridge.callRetStr('s_NetworkUtil_getNetIp',null, null, null, null, null,null,null);
}; 
NetworkUtil.getConnectState = function(netType)
{
   return stringToBool(Bridge.callRetStr('s_NetworkUtil_getConnectState', netType, null, null, null, null,null,null));
};
NetworkUtil.openApnSetting = function()
{	
   Bridge.callRetStr('s_NetworkUtil_openApnSetting',null, null, null, null, null,null,null);
}; 
NetworkUtil.startApnSetting = function()
{
   return stringToBool(Bridge.callRetStr('s_NetworkUtil_startApnSetting', null, null, null, null, null,null,null));
};
NetworkUtil.startConnectSetting = function()
{
   return stringToBool(Bridge.callRetStr('s_NetworkUtil_startConnectSetting', null, null, null, null, null,null,null));
};
NetworkUtil.getMobileConnectType = function()
{
   return stringToInt(Bridge.callRetStr('s_NetworkUtil_getMobileConnectType', null, null, null, null, null,null,null));
};


//系统原生程序相关操作类
var NativeUtil = {};
NativeUtil.getNativeVersion = function(packagename)
{	
   return Bridge.callRetStr('s_NativeUtil_getNativeVersion' ,packagename, null, null, null, null,null,null);
}; 
NativeUtil.startActivity = function(packagename,activity, parameter,type,errorCallFun)
{	
		if(arguments.length == 5)
		{
				
		}
		else if(arguments.length == 4)
		{
			 errorCallFun = null;
		}
		else if(arguments.length == 3)
		{
			 errorCallFun = null;
			 type = null;
		}
		else if(arguments.length == 2)
		{
			 errorCallFun = null;
			 type = null;
			 parameter = null;
		}
    Bridge.callByNotify(startActivityErrorCallFun,errorCallFun,null,null,null,'s_NativeUtil_startActivity' ,packagename, activity, parameter, type, null,null,null);
}; 
function startActivityErrorCallFun(id,result){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		if(callback.usercallback1)
		{
			callback.usercallback1(result);
		}		
}

NativeUtil.openSharedApp = function(url,param,downloadurl,alertmsg)
{
		if(arguments.length == 4)
	  {
	  	
	  }
	  else if(arguments.length == 3)
	  {
	  	alertmsg = null;
	  }
	  else if(arguments.length == 2)
	  {
	  	alertmsg = null;
	  	downloadurl = null;
	  }
	  else if(arguments.length == 1)
	  {
	  	alertmsg = null;
	  	downloadurl = null;
	  	param = null;
	  }
	  Bridge.callRetStr('s_NativeUtil_openSharedApp' ,url, param, downloadurl, alertmsg, null,null,null)
};


NativeUtil.installApk = function(apkFilePath,successCallBack)
{	
   Bridge.callByNotify(_successCallBack,successCallBack,null,null,null,'s_NativeUtil_installApk' ,apkFilePath, null, null, null, null,null,null);
}; 
function _successCallBack(id,packagename){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(packagename);
}
NativeUtil.isAppInstalled = function(packagename)
{	
   return stringToBool(Bridge.callRetStr('s_NativeUtil_isAppInstalled' ,packagename, null, null, null, null,null,null));
};
NativeUtil.uninstallApk = function(apkFilePath,successCallBack)
{	
   Bridge.callByNotify(_successCallBack,successCallBack,null,null,null,'s_NativeUtil_uninstallApk' ,apkFilePath, null, null, null, null,null,null);
}; 
function _successCallBack(id,packagename){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(packagename);
}
NativeUtil.selectCameraPhoto = function(callFunction,pwidth,iscrop)
{	
   Bridge.callByNotify(_callFunction,callFunction,null,null,null,'s_NativeUtil_selectCameraPhoto' ,pwidth, iscrop, null, null, null,null,null);
}; 
function _callFunction(id,path){
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(path);
}
NativeUtil.saveToAlbum = function(imgPath)
{	
   return stringToBool(Bridge.callRetStr('s_NativeUtil_saveToAlbum' ,imgPath, null, null, null, null,null,null));
};
NativeUtil.openImageContent = function(imgBase64)
{	
   return stringToBool(Bridge.callRetStr('s_NativeUtil_openImageContent' ,imgBase64, null, null, null, null,null,null));
};
NativeUtil.open = function(filePath)
{	
   Bridge.callRetStr('s_NativeUtil_open' ,filePath, null, null, null, null,null,null);
};
NativeUtil.startWifiServer = function()
{	
   Bridge.callRetStr('s_NativeUtil_startWifiServer' ,null, null, null, null, null,null,null);
};
NativeUtil.browser = function(url)
{	
   Bridge.callRetStr('s_NativeUtil_browser' ,url, null, null, null, null,null,null);
};

NativeUtil.openBaiduMapNavi = function(jsonData)
{	
   var text = JsonObjectToString(jsonData);
   Bridge.callRetStr('s_NativeUtil_openBaiduMapNavi' ,text, null, null, null, null,null,null);
};


var CellIdInfo = function()
{
	var text = '{"objName":"cellidinfo","cellId":"","countryCode":"","networkCode":"","locationAreaCode":"","radioType":""}';
	return ExmobiJSON.parse(text);
}


//File对象
var File = function(filepath,isforder)
{
	 this.filePath = filepath;
	 this.isForder = isforder;
	 this.objName = "file";
	 if(arguments.length == 1)
	 {
	 	 		this.isForder = false;
	 }
	 this.isFolder = function()
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_isFolder'  ,filepath, isforder, null, null, null,null,null));
	 }; 
	 this.getParent = function()
	 {
	 	  return Bridge.callRetStr('s_File_getParent'  ,filepath, isforder, null, null, null,null,null);
	 };
	 this.exists = function()
	 {
	 	  return stringToBool(Bridge.callRetStr('s_File_exists'  ,filepath, isforder, null, null, null,null,null));
	 };
	 this.length = function()
	 {
	 	   return stringToInt(Bridge.callRetStr('s_File_length'  ,filepath, isforder, null, null, null,null,null));
	 };
	 this.deleteFile = function()
	 {	 		
	 		return stringToBool(Bridge.callRetStr('s_File_deleteFile'  ,filepath, isforder, null, null, null,null,null));
	 };
	 this.mkdir = function()
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_mkdir'  ,filepath, isforder, null, null, null,null,null));
	 };
	 this.mkdirs = function()
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_mkdirs'  ,filepath, isforder, null, null, null,null,null));
	 };
	 this.createFile = function()
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_createFile'  ,filepath, isforder, null, null, null,null,null));
	 };	
	 this.renameTo = function(destPath)
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_renameTo'  ,filepath, isforder, destPath, null, null,null,null));
	 };	
	 this.copyTo = function(destPath)
	 {
	 		return stringToBool(Bridge.callRetStr('s_File_copyTo'  ,filepath, isforder, destPath, null, null,null,null));
	 };	
   this.getFilePath = function()
	 {
	 		return Bridge.callRetStr('s_File_getFilePath'  ,filepath, isforder, null, null, null,null,null);
	 };
	 this.getFileName = function()
	 {
	 		return Bridge.callRetStr('s_File_getFileName'  ,filepath, isforder, null, null, null,null,null);
	 }; 
	 this.getModifiedDate = function()
	 {
	 	  var text = Bridge.callRetStr('s_File_getModifiedDate'  ,filepath, isforder, null, null, null,null,null);
	 	  //Log.i("date",text);	 	  
	 	  var v = new Date(text);
	 	  return v;
	 };
	 this.list = function(filter)
	 {	 	 
	 	   if(arguments.length == 0)
	 	   {
	 	   	 filter = "";
	 	   }
	 	   var text = Bridge.callRetStr('s_File_list'  ,filepath, isforder, filter, null, null,null,null);	 	  
	 	   var v = ExmobiJSON.parse(text);	 	  
	 	   var arr = new Array();
	 	   for(var i = 0; i < v.length;i++)
	 	   {
	 	   	 arr.push(v[i].name);
	 	   }
	 	   return arr;
	 };
   this.listFiles = function(filter)
	 {	 	 
	 	   if(arguments.length == 0)
	 	   {
	 	   	 filter = "";
	 	   }
	 	   var text = Bridge.callRetStr('s_File_listFiles'  ,filepath, isforder, filter, null, null,null,null);	 	   
	 	   var v = ExmobiJSON.parse(text);	 	   
	 	   var arr = new Array();
	 	   for(var i = 0; i < v.length;i++)
	 	   {
	 	   	 var tmpfile = new File(v[i].name,stringToBool(v[i].isforder));
	 	   	 arr.push(tmpfile);
	 	   }
	 	   return arr;
	 };
}


//解码类处理 需要new Decode()
var Decode = function(){
  	this.objName = "decodewindow";
    this.onCallback = null;
    this.result = "";
	  this.time = "";
	  this.success = "false";
	  var context = this;
	  this.multipleResult;
	  this.isMultiple = false;
	  
    this.startDecode = function(isMultiple){
    	    //调用
    	    if(arguments.length==1)
    	    {
    	    this.isMultiple= isMultiple;
    	     Bridge.callByNotify(_Decode_onCallback,null,null,null,context,"s_Decode_startDecord",isMultiple, null, null, null, null,null,null);
    	    }else
    	    {
    	     Bridge.callByNotify(_Decode_onCallback,null,null,null,context,"s_Decode_startDecord",false, null, null, null, null,null,null);
    	    }
        
    };

}
//解码回调函数
function _Decode_onCallback(id, success, result, time){
    
    var callback =  Bridge.callbacks[id];
    if (callback.object == null){
      
       return;
    }else{
    	var decode = callback.object;
    	if( decode.isMultiple)
    	{
    	 decode.multipleResult = result;
    	}else
    	{
    	 decode.result = result;
    	}
		  decode.time = time;
		  decode.isSuccess = function(){
      return success == "true";
      }
      if(decode.onCallback !=null)
      {
         	decode.onCallback();
      }
    }
}




//Ajax类处理 new Ajax()
var Ajax = function(url,method,data,ajaxSuccessFunction,ajaxFailFunction,requestHeader,isShowProgress)
{	  
	  this.objName = "exmobiajax";
	  this.url = url;
	  this.method = method;
	  this.data = data;
	  this.onAjaxSuccessCallback = ajaxSuccessFunction;
    this.onAjaxFailCallback = ajaxFailFunction;
	  this.requestHeader = requestHeader;
	  this.isShowProgress = isShowProgress;
		var count = arguments.length;
		if(count == 6)
		{
			this.isShowProgress = null;
		}
		else if(count == 5)
		{
			this.isShowProgress = null;
			this.requestHeader = null;
		}
		else if(count == 4)
		{
			this.isShowProgress = null;
			this.requestHeader = null;
			this.onAjaxFailCallback = null;
		}
		else if(count == 3)
		{
			this.isShowProgress = null;
			this.requestHeader = null;
			this.onAjaxFailCallback = null;
			this.onAjaxSuccessCallback = null;
		}
		else if(count == 2)
		{
			this.isShowProgress = null;
			this.requestHeader = null;
			this.onAjaxFailCallback = null;
			this.onAjaxSuccessCallback = null;
			this.data = null;
		}
		else if(count == 1)
		{
			this.isShowProgress = null;
			this.requestHeader = null;
			this.onAjaxFailCallback = null;
			this.onAjaxSuccessCallback = null;
			this.data = null;
			this.method = null;
			this.url = JsonObjectToString(url);			
			if(typeof url.successFunction == "string")
			{
				this.onAjaxSuccessCallback = eval(url.successFunction);				
			}
			if(typeof url.failFunction == "string")
			{
				this.onAjaxFailCallback = eval(url.failFunction);
			}
		}
		
    var context = this;
   
    this.status = null;
    this.responseText = null;
    this.StringData = new WKHashMap();
    this.ArrayData = new WKHashMap();
    this.send = function()
    {
    	 
   		 //Log.i("ajax",this.url + " " + this.method + " " + this.data + " " + this.requestHeader + " " + this.isShowProgress);
       //存储callid与回调函数名
       Bridge.callByNotify(_Ajax_onSuccessCallback,null,_Ajax_onFailCallback,null,context,'s_Ajax_send' ,this.url, this.method, this.data, this.requestHeader, this.isShowProgress,null,null);
    };
    this.responseToFile = function(data)
    {
    	 //Log.i("Webkit Ajax responseToFile",this.responseText);
    	 var text = Bridge.callRetStr('s_Ajax_responseToFile',this.responseText,data, null, null, null,null,null);
    	 return stringToBool(text)
    };
    this.responseToXml = function()
    {    	
    	  //Log.i("Webkit Ajax responseToXml",this.responseText);
 				return loadXML(this.responseText);
    };
    this.setStringData = function(key,value)
    {
    	 this.StringData.put(key,value); 
    };
    this.getStringData = function(key)
    {
    	return this.StringData.get(key); 
    };
    this.setArrayData = function(key,value)
    {
    	this.ArrayData.put(key,value); 
    };
    this.getArrayData = function(key)
    {
    	return this.ArrayData.get(key); 
    };
}


//Ajax成功回调
function _Ajax_onSuccessCallback(id, status, responseText)
{
     //Log.i("Webkit", "bridgeclient is _Ajax_onSuccessCallback, status=" + status 
		//+ ", responseText=" + responseText + ",  callId=" + id);
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
    	 var ajax = callback.object;
       ajax.status = status;
       ajax.responseText = responseText;
       if (ajax.onAjaxSuccessCallback != null){
    	   
          ajax.onAjaxSuccessCallback(ajax);
       }
    }
}
//Ajax失败回调
function _Ajax_onFailCallback(id, status, responseText)
{
    //Log.i("Webkit", "bridgeclient is _Ajax_onFailCallback, status=" + status 
		//+ ", responseText=" + responseText + ",  callId=" + id);
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {      
       return;
    }
    else
    {
    	 var ajax = callback.object;
       ajax.status = status;
       ajax.responseText = responseText;
       if (ajax.onAjaxFailCallback != null)
       {    	   
          ajax.onAjaxFailCallback(ajax);
       }
    }
}

//DirectAjax类处理 new DirectAjax(jsonDataParameter)
var DirectAjax = function(jsonDataParameter)
{
    this.objName = "directajax";
    
    this.onAjaxSuccessCallback = null;
    this.onAjaxFailCallback = null;
    this.jsonData = jsonDataParameter;
    
    var count = arguments.length;
    if(count == 1)
    {
        this.jsonData = JsonObjectToString(jsonDataParameter);
        if(typeof jsonDataParameter.successFunction == "string")
        {
            this.onAjaxSuccessCallback = eval(jsonDataParameter.successFunction);
        }
        if(typeof jsonDataParameter.failFunction == "string")
        {
            this.onAjaxFailCallback = eval(jsonDataParameter.failFunction);
        }
    }
    
    var context = this;
    
    this.status = null;
    this.responseText = null;
    this.StringData = new WKHashMap();
    this.ArrayData = new WKHashMap();
    this.send = function()
    {
        //Log.i("directajax"," jsonText: " + this.jsonData);
        //存储callid与回调函数名
        Bridge.callByNotify(_Ajax_onSuccessCallback,null,_Ajax_onFailCallback,null,context,'s_DirectAjax_send' ,this.jsonData, null, null, null, null, null, null);
    };
    this.responseToFile = function(data)
    {
        //Log.i("Webkit DirectAjax responseToFile",this.responseText);
        var text = Bridge.callRetStr('s_Ajax_responseToFile',this.responseText,data, null, null, null,null,null);
        return stringToBool(text)
    };
    this.responseToXml = function()
    {
        //Log.i("Webkit DirectAjax responseToXml",this.responseText);
        return loadXML(this.responseText);
    };
    this.setStringData = function(key,value)
    {
        this.StringData.put(key,value);
    };
    this.getStringData = function(key)
    {
    	return this.StringData.get(key);
    };
    this.setArrayData = function(key,value)
    {
    	this.ArrayData.put(key,value);
    };
    this.getArrayData = function(key)
    {
    	return this.ArrayData.get(key);
    };
}

//DirectFormSubmit类处理 new DirectDownload(jsonDataParameter)
var DirectDownload = function(jsonDataParameter)
{
    this.objName = "directdownload";
    
    this.onDirectDownloadSuccessCallback = null;
    this.onDirectDownloadFailCallback = null;
    this.jsonData = jsonDataParameter;
    
    var count = arguments.length;
    if(count == 1)
    {
        this.jsonData = JsonObjectToString(jsonDataParameter);
        if(typeof jsonDataParameter.successFunction == "string")
        {
            this.onDirectDownloadSuccessCallback = eval(jsonDataParameter.successFunction);
        }
        if(typeof jsonDataParameter.failFunction == "string")
        {
            this.onDirectDownloadFailCallback = eval(jsonDataParameter.failFunction);
        }
    }
    
    var context = this;
    
    this.status = null;
    this.path = null;
    this.StringData = new WKHashMap();
    this.ArrayData = new WKHashMap();
    this.send = function()
    {
        //Log.i("DirectDownload", " jsonText: " + this.jsonData);
        //存储callid与回调函数名
        Bridge.callByNotify(_DirectDownload_onSuccessCallback,null,_DirectDownload_onFailCallback,null,context,'s_DirectDownload_send' ,this.jsonData, null, null, null, null, null, null);
    };
    this.responseToFile = function(data)
    {
        //Log.i("Webkit DirectDownload responseToFile",this.responseText);
        var text = Bridge.callRetStr('s_Ajax_responseToFile',this.path,data, null, null, null,null,null);
        return stringToBool(text)
    };
    this.responseToXml = function()
    {
        //Log.i("Webkit DirectDownload responseToXml",this.responseText);
        return loadXML(this.responseText);
    };
    this.setStringData = function(key,value)
    {
        this.StringData.put(key,value);
    };
    this.getStringData = function(key)
    {
    	return this.StringData.get(key);
    };
    this.setArrayData = function(key,value)
    {
    	this.ArrayData.put(key,value);
    };
    this.getArrayData = function(key)
    {
    	return this.ArrayData.get(key);
    };
}
//FormSubmit类处理 new FormSubmit(jsonDataParameter)
var FormSubmit = function(jsonDataParameter)
{
    this.objName = "formsubmit";

    this.onAjaxSuccessCallback = null;
    this.onAjaxFailCallback = null;
    this.jsonData = jsonDataParameter;

    var count = arguments.length;
    if(count == 1)
    {
        this.jsonData = JsonObjectToString(jsonDataParameter);
        if(typeof jsonDataParameter.successFunction == "string")
        {
            this.onAjaxSuccessCallback = eval(jsonDataParameter.successFunction);
        }
        if(typeof jsonDataParameter.failFunction == "string")
        {
            this.onAjaxFailCallback = eval(jsonDataParameter.failFunction);
        }
    }
    
    var context = this;
    
    this.status = null;
    this.responseText = null;
    this.StringData = new WKHashMap();
    this.ArrayData = new WKHashMap();
    this.send = function()
    {
        //Log.i("FormSubmit"," jsonText: " + this.jsonData);
        //存储callid与回调函数名
        Bridge.callByNotify(_Ajax_onSuccessCallback,null,_Ajax_onFailCallback,null,context,'s_FormSubmit_send' ,this.jsonData, null, null, null, null, null, null);
    };
    this.responseToFile = function(data)
    {
        //Log.i("Webkit DirectFormSubmit responseToFile",this.responseText);
        var text = Bridge.callRetStr('s_Ajax_responseToFile',this.responseText,data, null, null, null,null,null);
        return stringToBool(text)
    };
    this.responseToXml = function()
    {
        //Log.i("Webkit DirectFormSubmit responseToXml",this.responseText);
        return loadXML(this.responseText);
    };
    this.setStringData = function(key,value)
    {
        this.StringData.put(key,value);
    };
    this.getStringData = function(key)
    {
    	return this.StringData.get(key);
    };
    this.setArrayData = function(key,value)
    {
    	this.ArrayData.put(key,value);
    };
    this.getArrayData = function(key)
    {
    	return this.ArrayData.get(key);
    };
}
//DirectDownload成功回调
function _DirectDownload_onSuccessCallback(id, status, path)
{
    //Log.i("Webkit", "bridgeclient is _DirectDownload_onSuccessCallback, status=" + status
        //  + ", responseText=" + path + ",  callId=" + id);
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var ajax = callback.object;
        ajax.status = status;
        ajax.path = path;
        if (ajax.onDirectDownloadSuccessCallback != null){
            
            ajax.onDirectDownloadSuccessCallback(ajax);
        }
    }
}
//DirectDownload失败回调
function _DirectDownload_onFailCallback(id, status, path)
{
    //Log.i("Webkit", "bridgeclient is _DirectDownload_onFailCallback, status=" + status
         // + ", responseText=" + path + ",  callId=" + id);
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var ajax = callback.object;
        ajax.status = status;
        ajax.path = path;
        if (ajax.onDirectDownloadFailCallback != null)
        {
            ajax.onDirectDownloadFailCallback(ajax);
        }
    }
}

//DirectFormSubmit类处理 new DirectFormSubmit(jsonDataParameter)
var DirectFormSubmit = function(jsonDataParameter)
{
    this.objName = "directformsubmit";

    this.onAjaxSuccessCallback = null;
    this.onAjaxFailCallback = null;
    this.jsonData = jsonDataParameter;

    var count = arguments.length;
    if(count == 1)
    {
        this.jsonData = JsonObjectToString(jsonDataParameter);
        if(typeof jsonDataParameter.successFunction == "string")
        {
            this.onAjaxSuccessCallback = eval(jsonDataParameter.successFunction);
        }
        if(typeof jsonDataParameter.failFunction == "string")
        {
            this.onAjaxFailCallback = eval(jsonDataParameter.failFunction);
        }
    }
    
    var context = this;
    
    this.status = null;
    this.responseText = null;
    this.StringData = new WKHashMap();
    this.ArrayData = new WKHashMap();
    this.send = function()
    {
        //Log.i("DirectFormSubmit"," jsonText: " + this.jsonData);
        //存储callid与回调函数名
        Bridge.callByNotify(_Ajax_onSuccessCallback,null,_Ajax_onFailCallback,null,context,'s_DirectFormSubmit_send' ,this.jsonData, null, null, null, null, null, null);
    };
    this.responseToFile = function(data)
    {
        //Log.i("Webkit DirectFormSubmit responseToFile",this.responseText);
        var text = Bridge.callRetStr('s_Ajax_responseToFile',this.responseText,data, null, null, null,null,null);
        return stringToBool(text)
    };
    this.responseToXml = function()
    {
        //Log.i("Webkit DirectFormSubmit responseToXml",this.responseText);
        return loadXML(this.responseText);
    };
    this.setStringData = function(key,value)
    {
        this.StringData.put(key,value);
    };
    this.getStringData = function(key)
    {
    	return this.StringData.get(key);
    };
    this.setArrayData = function(key,value)
    {
    	this.ArrayData.put(key,value);
    };
    this.getArrayData = function(key)
    {
    	return this.ArrayData.get(key);
    };
}


//Exmobi Window

var ExMobiWindow=
{	 
	 open:function(url, isNewWindow,isPop,features,param)
	 {
	 	  var count = arguments.length;
	 	  //Log.i("Webkit ExmobiWindow","open arguments:" + count);
	 		if(count == 5)
	 		{
	 			 Bridge.callRetStr('s_window_open'  ,url, isNewWindow, isPop, features, param,null,null);
	 		}
	 		else if(count == 4)
	 		{
	 			 Bridge.callRetStr('s_window_open'  ,url, isNewWindow, isPop, features, null,null,null);
	 		}
	 		else if(count == 3)
 			{
 				Bridge.callRetStr('s_window_open'  ,url, isNewWindow, isPop, null, null,null,null);
 			}
 			else if(count == 2)
 			{
 				Bridge.callRetStr('s_window_open'  ,url, isNewWindow, null, null, null,null,null);
 			}
 			else
 			{
 				Bridge.callRetStr('s_window_open'  ,url, null, null, null, null,null,null);
 			}	 	  
	 },	
	 	 openData:function(data, isNewWindow,isPop,features,param)
	 {
	 	  var count = arguments.length;
	 	  //Log.i("Webkit ExmobiWindow","openData arguments:" + count);
	 		if(count == 5)
	 		{
	 			 Bridge.callRetStr('s_window_openData'  ,data, isNewWindow, isPop, features, param,null,null);
	 		}
	 		else if(count == 4)
	 		{
	 			 Bridge.callRetStr('s_window_openData'  ,data, isNewWindow, isPop, features, null,null,null);
	 		}
	 		else if(count == 3)
 			{
 				Bridge.callRetStr('s_window_openData'  ,data, isNewWindow, isPop, null, null,null,null);
 			}
 			else if(count == 2)
 			{
 				Bridge.callRetStr('s_window_openData'  ,data, isNewWindow, null, null, null,null,null);
 			}
 			else
 			{
 				Bridge.callRetStr('s_window_openData'  ,data, null, null, null, null,null,null);
 			}	 	  
	 },	  
	 getParameter:function(param)
	 {
	 	  return Bridge.callRetStr('s_window_getParameter'  ,param, null, null, null, null,null,null);
	 },
	 setStringSession:function(key,value)
	 {	   
	 		Bridge.callRetStr('s_window_setStringSession'  ,key, value, null, null, null,null,null);
	 },
	 getStringSession:function(key)
	 {
	 	  var res = Bridge.callRetStr('s_window_getStringSession'  ,key, null, null, null, null,null,null);
	 	  if(res == "null")
	 	  {
	 	  	 return null;
	 	  }
	 	  return res;
	 },
	 setArraySession:function(key,array)
	 {	   	
	 	  var text = arrayToJsonString(array);	 	 
	 		Bridge.callRetStr('s_window_setArraySession'  ,key, text, null, null, null,null,null);
	 },	 
	 getArraySession:function(key)
	 { 	 
	 	  var res = Bridge.callRetStr('s_window_getArraySession'  ,key, null, null, null, null,null,null);	 	 
	 	  return jsonStringToArray(res);	
	 },
	 getPushParameters:function()
	 {
	 	  var res = Bridge.callRetStr('s_window_getPushParameters'  ,null, null, null, null, null,null,null);
	 	  if(res == "null")
	 	    return null;
	 	  return ExmobiJSON.parse(res);
	 },
	 getPushParameter:function(key)
	 {	 	  
	 	  var res = Bridge.callRetStr('s_window_getPushParameter'  ,key, null, null, null, null,null,null);
	 	  return res;
	 },
	 getNativeParameter:function(key)
	 {
	 		var res = Bridge.callRetStr('s_window_getNativeParameter'  ,key, null, null, null, null,null,null);
	 	  if(res == "null")
	 	  {
	 	  	 return null;
	 	  }
	 	  return res;
	 },
	 getNativeParameters:function()
	 {
	 		var res = Bridge.callRetStr('s_window_getNativeParameters'  ,null, null, null, null, null,null,null);
	 	  return ExmobiJSON.parse(res);
	 },
	 callExMobiFunction:function(script)
	 {
	 	  return Bridge.callRetStr('s_window_callExMobiFunction'  ,script, null, null, null, null,null,null);
	 },
	 	 	 close:function()
	 {
	 		nativePage.executeScript("window.close();");
	 		//Bridge.callRetStr('s_window_close'  ,null, null, null, null, null,null,null);	
	 },
	      alert:function(message, callback)
     {
         Bridge.callByNotify(_ExMobiWindow_alert_onCallback,callback,null,null,this,'s_window_alert' ,message, null, null, null, null, null, null);
     },
     confirm:function(message, okCallback, cancelCallback)
     {
         Bridge.callByNotify(_ExMobiWindow_confirm_okCallback,okCallback,_ExMobiWindow_confirm_cancelCallback,cancelCallback,this,'s_window_confirm' ,message, null, null, null, null, null, null);
     },
     	clearStringSession:function()
	{
		Bridge.callRetStr('s_window_clearStringSession'  ,null, null, null, null, null,null,null);
	},
	clearArraySession:function()
	{
		Bridge.callRetStr('s_window_clearArraySession'  ,null, null, null, null, null,null,null);
	}
     
     
};

function _ExMobiWindow_alert_onCallback(id)
{
    //获取回调对象
    var callback = Bridge.callbacks[id];
    //调用回调函数
    callback.usercallback1();
}
function _ExMobiWindow_confirm_okCallback(id)
{
    //获取回调对象
    var callback = Bridge.callbacks[id];
    //调用回调函数
    callback.usercallback1();
}
function _ExMobiWindow_confirm_cancelCallback(id)
{
    //获取回调对象
    var callback = Bridge.callbacks[id];
    //调用回调函数
    callback.usercallback2();
}

function ParameterInfo()
{
    this.objName = "parameterinfo";
    this.key = "";
    this.value = "";
}


function BgServiceStatus()
{	
	this.objName = "";
	this.id = 0;
	this.name = "";
	this.type = 0;
	this.status = 0;
	this.startTime = "";
	this.endTime = "";
	this.result = 0;
	this.resultText = "";
}

//后台任务上传
var BgServiceUtil=
{	 
	 addFormSubmitJob:function(formSubmitJobJson)
	 {
	 		var jsonString = JsonObjectToString(formSubmitJobJson);
	 		//Log.i("Webkit BgServiceUtil addFormSubmitJob","jsonString:" + jsonString);	 	  
	 		return Bridge.callRetStr('s_BgServiceUtil_addFormSubmitJob'  ,jsonString, null, null, null, null,null,null); 		
	 },
	 openBgServiceManagerUI:function()
	 {	 		 
	 		 Bridge.callRetStr('s_BgServiceUtil_openBgServiceManagerUI'  ,null, null, null, null, null,null,null); 		
	 },
	 removeJob:function(jobId)
	 {
	 		//Log.i("Webkit BgServiceUtil removeJob","id:" + jobId);	 	  
	 		var ret = Bridge.callRetStr('s_BgServiceUtil_removeJob'  ,jobId, null, null, null, null,null,null);
	 		return stringToBool(ret);	
	 },
	 getJobStatus:function(jobId)
	 {	 		
	 		//Log.i("webkit","getJobStatus");
	 		var text = Bridge.callRetStr('s_BgServiceUtil_getJobStatus' ,jobId, null, null, null, null,null,null);	 		
	 		//Log.i("webkit",text);
	 		if(text == "null")
	 		{
	 			return null;
	 		}
	 		else
	 		{
	 				var json = ExmobiJSON.parse(text);
	 				var v = new BgServiceStatus();
	 				v.id = stringToInt(json.id);
	 				v.name = json.name;
	 				v.type = stringToInt(json.type);
	 				v.status = stringToInt(json.status);
	 				v.startTime = json.startTime;
	 				v.endTime = json.endTime;
	 				v.result = stringToInt(json.result);
	 				v.resultText = json.resultText;
	 				v.objName = json.objName;
	 				return v;
	 		}
	 },
	 getJobInfo:function(jobId)
	{	 		
	 		var text = Bridge.callRetStr('s_BgServiceUtil_getJobInfo' ,jobId, null, null, null, null,null,null);	 		
	 		if(text == "null")
	 		{
	 			  return null;
	 		}
	 	  else
	 		{
	 				var json = ExmobiJSON.parse(text);	 			
	 			  return json;
	 		}
	}
};
 
 //百度定位
var BaiduLocationID = 0;
var BaiduLocation = function()
{
	this.objName = "baidulocation";
	this.onCallback = null;
	this.latitude = 0;
	this.longitude = 0;
	this.address = "";
	this.locationtime = "";
	this.statuscode = -1;
	this.accuracy = 1;
	this.province = "";
	this.city = "";
	this.district = "";
	this.street = "";
	this.streetNumber = "";
	this.id = BaiduLocationID++;
	
  this.setCoorType = function(coorType)
  {
  	Bridge.callRetStr('s_BaiduLocation_setCoorType' ,this.id, coorType, null, null, null,null,null);
  };
	this.setOpenGps = function(isOpenGps)
	{
		Bridge.callRetStr('s_BaiduLocation_setOpenGps' ,this.id, isOpenGps, null, null, null,null,null);
	};
  this.disableCache = function(isCache)
	{
		Bridge.callRetStr('s_BaiduLocation_disableCache' ,this.id, isCache, null, null, null,null,null);
	};
	this.setTimeout = function(millisecond)
	{		
		Bridge.callRetStr('s_BaiduLocation_setTimeout' ,this.id, millisecond, null, null, null,null,null);
	};
	this.startPosition = function()
	{
		Bridge.callByNotify(_BaiduLocation_onCallback,null,null,null,this,'s_BaiduLocation_startPosition' ,this.id, null, null, null, null, null, null);		
	};
	this.stopPosition = function()
	{
		Bridge.callRetStr('s_BaiduLocation_stopPosition' ,this.id, null, null, null, null,null,null);
	};
	this.isSuccess = function()
	{
		var text = Bridge.callRetStr('s_BaiduLocation_isSuccess' ,this.id, null, null, null, null,null,null);
		return stringToBool(text);
	};
};

function _BaiduLocation_onCallback(id, text)
{    
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var baiduLocation = callback.object;
        var json = ExmobiJSON.parse(text);
        baiduLocation.latitude = stringToDouble(json.latitude);
        baiduLocation.longitude = stringToDouble(json.longitude);
        baiduLocation.address = json.address;
        baiduLocation.locationtime = json.locationtime;
        baiduLocation.statuscode = stringToInt(json.statuscode);
        baiduLocation.accuracy = json.accuracy;
        baiduLocation.province = json.province;
        baiduLocation.city = json.city;
        baiduLocation.district= json.district;
        baiduLocation.street= json.street;
        baiduLocation.streetNumber = json.streetNumber;
        
        if (baiduLocation.onCallback != null)
        {            
            baiduLocation.onCallback();
        }
    }
}


//百度定位
var GpsID = 0;
var Gps = function()
{
	this.objName = "gps";
	this.onCallback = null;
	this.latitude = 0;
	this.longitude = 0;
	this.locationtime = "";
	this.accuracy = 1;
	this.altitude = "";
	this.speed = "";
	this.id = GpsID++;
	
 
	this.setTimeout = function(millisecond)
	{		
		Bridge.callRetStr('s_Gps_setTimeout' ,this.id, millisecond, null, null, null,null,null);
	};
	this.startPosition = function()
	{
		Bridge.callByNotify(_Gps_onCallback,null,null,null,this,'s_Gps_startPosition' ,this.id, null, null, null, null, null, null);		
	};
	this.stopPosition = function()
	{
		Bridge.callRetStr('s_Gps_stopPosition' ,this.id, null, null, null, null,null,null);
	};
	this.isSuccess = function()
	{
		var text = Bridge.callRetStr('s_Gps_isSuccess' ,this.id, null, null, null, null,null,null);
		return stringToBool(text);
	};
};

function _Gps_onCallback(id, text)
{    
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var gps = callback.object;
        var json = ExmobiJSON.parse(text);
        gps.latitude = stringToDouble(json.latitude);
        gps.longitude = stringToDouble(json.longitude);       
        gps.locationtime = json.locationtime;        
        gps.accuracy = json.accuracy;
        gps.altitude = json.altitude;
        gps.speed = json.speed;         
        if (gps.onCallback != null)
        {            
            gps.onCallback();
        }
    }
}


//百度定位
var LocationID = 0;
var Location = function()
{
	this.objName = "location";
	this.onCallback = null;
	this.latitude = 0;
	this.longitude = 0;	
	this.locationtime = "";
	this.location = "";	
	this.province = "";
	this.city = "";
	this.district = "";
	this.street = "";
	this.streetNumber = "";
	this.id = LocationID++;
	
  this.startGetLocationInfo = function(latitude, longitude,coordType)
  {
  	Bridge.callByNotify(_Location_onCallback,null,null,null,this,'s_Location_startGetLocationInfo' ,this.id, latitude, longitude, coordType, null, null, null);		  
  };
	this.stopGetLocationInfo = function()
	{
		Bridge.callRetStr('s_Location_stopGetLocationInfo' ,this.id, null, null, null, null,null,null);
	};
  this.getMessageCode = function()
	{
		var text = Bridge.callRetStr('s_Location_getMessageCode' ,this.id, null, null, null, null,null,null);
		return stringToInt(text);
	};
	this.setTimeout = function(millisecond)
	{		
				Bridge.callRetStr('s_Location_setTimeout' ,this.id, millisecond, null, null, null,null,null);
	};	
	this.isSuccess = function()
	{
				var text = Bridge.callRetStr('s_Location_isSuccess' ,this.id, null, null, null, null,null,null);
		return stringToBool(text);
	};
};

function _Location_onCallback(id, text)
{    
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
        var location = callback.object;
        var json = ExmobiJSON.parse(text);
        location.latitude = stringToDouble(json.latitude);
        location.longitude = stringToDouble(json.longitude);
        location.location = json.location;
        location.locationtime = json.locationtime;      
        location.province = json.province;
        location.city = json.city;
        location.district= json.district;
        location.street= json.street;
        location.streetNumber = json.streetNumber;     
        if (location.onCallback != null)
        {            
            location.onCallback();
        }
    }
}
 
 //CacheInfo类
var CacheInfo = function()
{
    this.objName = "cacheinfo";
    this.key = "";
    this.value = "";
}

//cache类
var CacheUtil = {};
CacheUtil.getCache = function(key)
{
    return Bridge.callRetStr('s_CacheUtil_getCache',key, null, null, null, null,null,null);
}
CacheUtil.setCache = function(key, value)
{
    Bridge.callRetStr('s_CacheUtil_setCache',key, value, null, null, null,null,null);
}
CacheUtil.remove = function(key)
{
    return stringToBool(Bridge.callRetStr('s_CacheUtil_remove',key, null, null, null, null,null,null));
}
CacheUtil.clear = function()
{
    return stringToBool(Bridge.callRetStr('s_CacheUtil_clear',null, null, null, null, null,null,null));
}
CacheUtil.getCaches = function(keyPart)
{
    var res = Bridge.callRetStr('s_CacheUtil_getCaches',keyPart, null, null, null, null,null,null);
    //Log.i("Cache getCaches", res);
    if(res == "null")
    {
        return null;
    }
    else
    {
        var json = ExmobiJSON.parse(res);
        
        var arr = new Array();
        for(var i = 0; i < json.length;i++)
        {
            var temp = new CacheInfo();
            temp.key = json[i].key;
            temp.value = json[i].value;
            
            arr.push(temp);
        }
        return arr;
    }
}
 
 //手势密码类
var PatternUtil=
{	 
	 disablePattern:function()
	 {	 		 	  
	 		return Bridge.callRetStr('s_PatternUtil_disablePattern'  ,null, null, null, null, null,null,null); 		
	 },
	 enablePattern:function()
	 {	 		 
	 		 Bridge.callRetStr('s_PatternUtil_enablePattern'  ,null, null, null, null, null,null,null); 		
	 },
	 isPattern:function()
	 {	 	 	  
	 		var ret = Bridge.callRetStr('s_PatternUtil_isPattern'  ,null, null, null, null, null,null,null);
	 		return stringToBool(ret);	
	 },
	 isSetPatternPassword:function()
	 {	 		
	 	 	var ret = Bridge.callRetStr('s_PatternUtil_isSetPatternPassword'  ,null, null, null, null, null,null,null);
	 		return stringToBool(ret);	
	 },
	 getPatternCheckNumber:function()
	 {	 		
	 		var ret = Bridge.callRetStr('s_PatternUtil_getPatternCheckNumber' ,null, null, null, null, null,null,null);	 		
	 		return stringToInt(ret);	
	 },
	 getPatternMinLength:function()
	 {	 		
	 		var ret = Bridge.callRetStr('s_PatternUtil_getPatternMinLength' ,null, null, null, null, null,null,null);	 		
	 		return stringToInt(ret);	
	 },
	 getPatternTimeout:function()
	 {	 		
	 		var ret = Bridge.callRetStr('s_PatternUtil_getPatternTimeout' ,null, null, null, null, null,null,null);	 		
	 		return stringToInt(ret);	
	 },
	 openPattern:function(successCallback)
	 {	
	 		  Bridge.callByNotify(PatternUtilOpenPatternCallBack,successCallback,null,null,null,'s_PatternUtil_openPattern',null,null,null,null, null, null,null);		 	
	 },
	 openSetPattern:function(successCallback)
	 {	
	 		  Bridge.callByNotify(PatternUtilopenSetPatternCallBack,successCallback,null,null,null,'s_PatternUtil_openSetPattern',null,null,null,null, null, null,null);		 	
	 },
	 setPatternCheckNumber:function(number)
	 {	
	 	  var ret = Bridge.callRetStr('s_PatternUtil_setPatternCheckNumber' ,number, null, null, null, null,null,null);	 		
	 		return stringToBool(ret);			 	
	 },
	 setPatternForgetUrl:function(url)
	 {	
	 	  Bridge.callRetStr('s_PatternUtil_setPatternForgetUrl' ,url, null, null, null, null,null,null);	 			 		 	
	 }, 
	 setPatternMinLength:function(num)
	 {	
	 	  var ret = Bridge.callRetStr('s_PatternUtil_setPatternMinLength' ,num, null, null, null, null,null,null);	 		
	 		return stringToBool(ret);			 	
	 }, 
	 setPatternTimeout:function(time)
	 {	
	 	 Bridge.callRetStr('s_PatternUtil_setPatternTimeout' ,time, null, null, null, null,null,null);	 	 					 	
	 }, 
	 getPatternPassword:function()
	 {		 	 
	 	 var ret = Bridge.callRetStr('s_PatternUtil_getPatternPassword' ,null, null, null, null, null,null,null);	 	 		
	 	 if(ret == "null")
	 	 {
	 	 		return null;
	 	 }			 
	 	 else
	 	 {
	 	 		return ret;
	 	 }	
	 },
	 setPatternPassword:function(password)
	 {	
	 	 var ret = Bridge.callRetStr('s_PatternUtil_setPatternPassword' ,password, null, null, null, null,null,null);	
	 	 return stringToBool(ret);	 	 					 	
	 },
	 setPatternPassword:function(password)
	 {	
	 	 var ret = Bridge.callRetStr('s_PatternUtil_setPatternPassword' ,password, null, null, null, null,null,null);	
	 	 return stringToBool(ret);	 	 					 	
	 },
	 setPatternLogo:function(logo)
	 {	
	 	 Bridge.callRetStr('s_PatternUtil_setPatternLogo' ,logo, null, null, null, null,null,null);		 		 	 					 	
	 },
	 setPatternPrompt:function(prompt)
	 {	
	 	 Bridge.callRetStr('s_PatternUtil_setPatternPrompt' ,prompt, null, null, null, null,null,null);		 		 	 					 	
	 },
	 getPatternPrompt:function()
	 {	
	 	 var ret = Bridge.callRetStr('s_PatternUtil_getPatternPrompt' ,null, null, null, null, null,null,null);
	 	 if(ret == "null")
	 	 {
	 	 		return null;
	 	 }			 
	 	 else
	 	 {
	 	 		return ret;
	 	 }			 		 	 					 	
	 },
	 getPatternLogo:function()
	 {	
	 	 var ret = Bridge.callRetStr('s_PatternUtil_getPatternLogo' ,null, null, null, null, null,null,null);
	 	 if(ret == "null")
	 	 {
	 	 		return null;
	 	 }			 
	 	 else
	 	 {
	 	 		return ret;
	 	 }			 		 	 					 	
	 }
};

function PatternUtilOpenPatternCallBack(id)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1();
}
function PatternUtilopenSetPatternCallBack(id,ret)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(ret);
}

function SangforInfo()
{
	this.vpnIp = "";
	this.vpnPort = "";
	this.authName = "";
	this.authPassword = "";
	this.certFile = "";
	this.certPassword = "";
	this.objName = "sangforinfo";
	this.smsAuthCode = "";
} 
//深信服
var SangforUtil=
{	 
	 getSangforInfo:function()
	 {	
	 		var text = Bridge.callRetStr('s_SangforUtil_getSangforInfo' ,null, null, null, null, null,null,null);	 		
	 		//Log.i("SangforUtil getSangforInfo",text);
	 		if(text == "null")
	 		{
	 			return null;
	 		}
	 		else
	 		{
	 				var json = ExmobiJSON.parse(text);
	 				var v = new SangforInfo();
	 				v.vpnIp = json.vpnIp;
	 				v.vpnPort = stringToInt(json.vpnPort);
	 				v.authName = json.authName;
	 				v.authPassword = json.authPassword;
	 				v.certFile = json.certFile;
	 				v.certPassword = json.certPassword;
	 				v.objName = "sangforinfo";
	 				v.smsAuthCode = json.smsAuthCode;	 			
	 				return v;
	 		}		 		
	 },
	 getSangforVpnStatus:function()
	 {
	 		var ret = Bridge.callRetStr('s_SangforUtil_getSangforVpnStatus' ,null, null, null, null, null,null,null);	
	 		return stringToInt(ret);		
	 },
	 saveSangforInfo:function(sangforInfo)
	 {
	 		 var text = '{';
	 		 text = text + '"objName":"' + sangforInfo.objName + '"' + ',';
	 		 text = text + '"vpnIp":"' + sangforInfo.vpnIp + '"' + ',';
	 		 text = text + '"vpnPort":"' + sangforInfo.vpnPort + '"' + ',';
	 		 text = text + '"authName":"' + sangforInfo.authName + '"' + ',';
	 		 text = text + '"authPassword":"' + sangforInfo.authPassword + '"' + ',';
	 		 text = text + '"certFile":"' + sangforInfo.certFile + '"' + ',';
	 		 text = text + '"certPassword":"' + sangforInfo.certPassword + '"' + ',';
	 		 text = text + '"smsAuthCode":"' + sangforInfo.smsAuthCode + '"';
	 		 text = text + '}';
	 		 Bridge.callRetStr('s_SangforUtil_saveSangforInfo' ,text, null, null,null,null,null,null);
	 },
	 startSangforVpn:function(vpnCallBack)
	 {
	 		 Bridge.callByNotify(SangforStartSangforVpnCallBack,vpnCallBack,null,null,null,'s_SangforUtil_startSangforVpn',null,null,null,null, null, null,null);
	 },
	 stopSangforVpn:function(vpnCallBack)
	 {
	 		 Bridge.callByNotify(SangforStopSangforVpnCallBack,vpnCallBack,null,null,null,'s_SangforUtil_stopSangforVpn',null,null,null,null, null, null,null);
	 },
	  startSmsLogin:function(smsCode,smsCallBack)
	 {
	 	  //Log.i("1","33");
	 		Bridge.callByNotify(SangforStopSangforVpnCallBack,smsCallBack,null,null,null,'s_SangforUtil_startSmsLogin',smsCode,null,null,null, null, null,null);
	 },
	 refreshSms:function()
	 {
	 		 Bridge.callRetStr('s_SangforUtil_refreshSms' ,null, null, null,null,null,null,null);
	 }
	

	
};

function SangforStartSangforVpnCallBack(id,ret)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(ret);
}
function SangforStopSangforVpnCallBack(id,ret)
{
		//获取回调对象
		var callback = Bridge.callbacks[id];
		//调用回调函数
		callback.usercallback1(ret);
}

//应用管理
var AppManager = function()
{	  
	  this.objName = "appmanager";
	  this.onGetAppsCallback = null;
      this.onSetupAppCallback = null;
	  this.onRemoveAppCallback = null;
	  
	  this.isGetAppsShowProgress = true;
	  this.isSetupAppShowProgress = true;
	  this.isRemoveAppShowProgress = true;
	  
	  this.isGetAppsSuccess_ = false;
	  this.isSetupAppSuccess_ = false;
	  this.isRemoveAppSuccess_ = false;
	  
	  this.applicationInfos;
	  var context = this;
	  
	 this.startGetApps = function()
    {
       Bridge.callByNotify(_AppManager_onGetAppsCallback,null,null,null,context,'s_AppManager_startGetApps',this.isGetAppsShowProgress, null, null, null, null,null,null);
    };
    this.isGetAppsSuccess = function()
    {
    	return this.isGetAppsSuccess_;
    };
    
     this.startSetupApp = function(appid)
    {
       Bridge.callByNotify(_AppManager_onSetupAppCallback,null,null,null,context,'s_AppManager_startSetupApp' ,this.isSetupAppShowProgress, appid, null, null, null,null,null);
    };
    this.isSetupAppSuccess = function()
    {
    	return this.isSetupAppSuccess_;
    };
    
        this.startRemoveApp = function(appid)
    {
       Bridge.callByNotify(_AppManager_onRemoveAppCallback,null,null,null,context,'s_AppManager_startRemoveApp' ,this.isRemoveAppShowProgress, appid, null, null, null,null,null);
    };
    this.isRemoveAppSuccess = function()
    {
    	return this.isRemoveAppSuccess_;
    };
		 
};

//获取应用列表回调
function _AppManager_onGetAppsCallback(id, isGetAppsSuccess, appinfoJson)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var appmanager = callback.object;
        appmanager.isGetAppsSuccess_ = isGetAppsSuccess;
    	appmanager.applicationInfos = ExmobiJSON.parse(appinfoJson).applist;
        if (appmanager.onGetAppsCallback != null){
          appmanager.onGetAppsCallback();
       }
    }
}
//安装应用回调
function _AppManager_onSetupAppCallback(id, isSetupAppSuccess)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var appmanager = callback.object;
        appmanager.isSetupAppSuccess_ = isSetupAppSuccess;
        if (appmanager.onSetupAppCallback != null){
          appmanager.onSetupAppCallback();
       }
    }
}
//卸载应用应用回调
function _AppManager_onRemoveAppCallback(id, isRemoveAppSuccess)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var appmanager = callback.object;
        appmanager.isRemoveAppSuccess_ = isRemoveAppSuccess;
        if (appmanager.onRemoveAppCallback != null){
          appmanager.onRemoveAppCallback();
       }
    }
}

//拍照
var CameraWindow = function()
{	  
	  this.objName = "camerawindow";
	  this.onCallback = null;
      this.mode = "still";
	  this.quality = "normal";
	  
	  this.path = "sys:data/tmp";
	  this.filename = "";
	  this.value = "";
	  this.pwidth = 0;
	  this.savealbum = false;
	  this.success = false;
	  this.compress = 100;
	  this.iscrop = false;
	  this.usecustomcamera = false;
	  this.isfront = false;
	  var context = this;
	  
	
	  
	 this.startCamera = function()
    {
      var json = {};
	  json.compress = this.compress;
	  json.iscrop = this.iscrop;
	  json.usecustomcamera = this.usecustomcamera;
	  json.isfront = this.isfront;
	  var jsonString = JsonObjectToString(json);
       Bridge.callByNotify(_CameraWindow_onCallback,null,null,null,context,'s_CameraWindow_startCamera',this.mode, this.quality, this.path, this.filename, this.pwidth,this.savealbum,jsonString);
    };
    this.isSuccess = function()
    {
    	return this.success;
    };
		 
};

//拍照回调
function _CameraWindow_onCallback(id, isSuccess, value)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var camerawindow = callback.object;
        camerawindow.success = isSuccess;
    	camerawindow.value = value;
        if (camerawindow.onCallback != null){
          camerawindow.onCallback();
       }
    }
}

//progressBar进度条
var ProgressBar = function()
{	  
	  this.objName = "progressbar";
	  this.onTimeoutCallback = null;
      this.timeout = 0;
	  this.message="";
	  this.isBlock = true;
	  
	  var context = this;
	  
	 this.show = function(block)
    {
       var count = arguments.length
	 	if(count == 1)
	    {
	 		this.isBlock = block;
	 	}
       Bridge.callByNotify(_ProgressBar_onTimeoutCallback,null,null,null,context,'s_ProgressBar_show',this.timeout,this.message,this.isBlock,null, null,null,null);
    };
    this.setMessage = function(msg)
    {
    	this.message = msg;
    };
	  this.cancel = function()
    {
       Bridge.callByNotify(null,null,null,null,context,'s_ProgressBar_cancel',null, null, null, null,null,null,null);
    };
};

//超时回调
function _ProgressBar_onTimeoutCallback(id)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var progressbar = callback.object;
        if (progressbar.onTimeoutCallback != null){
          progressbar.onTimeoutCallback();
       }
    }
}

//时间选择器
var TimeWindow = function()
{	  
	  this.objName = "timewindow";
	  this.onCallback = null;
      this.initialvalue = "";
	  this.mode = "date";
	  this.result = "";
	  this.success = false;
	  
	  
	  var context = this;
	  
	 this.startWindow = function()
    {
       Bridge.callByNotify(_TimeWindow_onCallback,null,null,null,context,'s_TimeWindow_startWindow',this.initialvalue, this.mode, null,null,null,null,null);
    };
    this.isSuccess = function()
    {
    	return this.success;
    };
		 
};

//选择时间回调
function _TimeWindow_onCallback(id, isSuccess, result)
{
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {     
       return;
    }
    else
    {
        var timewindow = callback.object;
        if(isSuccess=="true")
        {
         timewindow.success = true;
        }else
        {
         timewindow.success = false;
        }
    	timewindow.result = result;
        if (timewindow.onCallback != null){
          timewindow.onCallback();
       }
    }
}


//图片选择
var ImageChoice = function()
{
   
    this.objName = "imagechoice";
	this.nums  = 5;
    this.onCallback  = null;
    this.pwidth = 0;
    this.rsultjson = "";
    this.path = "sys:data/tmp";
    
    var context = this;
    this.start = function()
    {
         Bridge.callByNotify(_imageChoice_onCallback,null,null,null,context,"s_ImageChoice_start",this.nums,this.pwidth,this.path,null,null,null,null);
    };
   
     this.getFilePaths = function()
    {
        return jsonStringToArray(this.rsultjson)
    };
  
};
//ImageChoice回调函数
function _imageChoice_onCallback(id,paths)
{

    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
    	var imageChoice = callback.object;
    	imageChoice.rsultjson = paths;
        if(imageChoice.onCallback != null)
        {
        var resultarray = jsonStringToArray(paths);
         imageChoice.onCallback(resultarray);
        }
    }
}

//文件选择
//FileChoice对象id
var FileChoice = function()
{
   
    this.objName = "filechoice";
    this.onCallback  = null;
    this.value = "";
    this.defaultPath="/";
    this.filter="";
    
    var context = this;
    this.start = function()
    {
         Bridge.callByNotify(_fileChoice_onCallback,null,null,null,context,"s_FileChoice_start",this.defaultPath,this.filter, null, null,null,null,null);
    };
  
};
//FileChoice回调函数
function _fileChoice_onCallback(id,path)
{

    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
    	var fileChoice = callback.object;
    	fileChoice.value = path;
        if(fileChoice.onCallback != null)
        {
         fileChoice.onCallback(path);
        }
    }
}

//通话录音
//PhoneRecord对象id
var PhoneRecord = function()
{
   
    this.objName = "phonerecord";
    this.onCallback  = null;
    this.path = "sys:data/tmp";
    
    var context = this;
    this.start = function()
    {
         Bridge.callByNotify(_phonerecord_onCallback,null,null,null,context,"s_PhoneRecord_start",this.path,null, null, null,null,null,null);
    };
  
};
//PhoneRecord回调函数
function _phonerecord_onCallback(id,path)
{

    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
    	var phonerecord = callback.object;
    	phonerecord.path = path;
        if(phonerecord.onCallback != null)
        {
         phonerecord.onCallback(path);
        }
    }
}


//邮件对象
var mailobjectid = 0;
var MailObject = function()
{
    this.id = mailobjectid++;
    this.to = "";
    this.cc = "";
    this.bcc = "";
    this.subject = "";
    this.body = "";
    
    var context = this;
    
    this.show = function()
    {
        Bridge.callRetStr('s_MailObject_show' ,this.id,this.to, this.cc, this.bcc,this.subject,this.body,null);
    };
    this.setAttachments = function(attachments)
    {
        var jsonText = arrayToJsonString(attachments);
    	Bridge.callRetStr('s_MailObject_setAttachments', this.id, jsonText, null, null, null, null, null);
    };
    this.getAttachments = function()
    {
        var res = Bridge.callRetStr('s_MailObject_getAttachments', this.id, null, null, null, null, null, null);
        if("null" == res)
        {
            return null;
        }
        else
        {
            return jsonStringToArray(res);
        }
    }
};


//后台定位
var BgLocationUtil = {};
/*1*/
BgLocationUtil.setBgLocationUrl = function(urlJson){
    var jsonText = JsonObjectToString(urlJson);
	return stringToBool(Bridge.callRetStr('s_BgLocationUtil_setBgLocationUrl',jsonText, null, null,null,null,null,null));
}
/*2*/
BgLocationUtil.queryTask = function(dataJson,queryTaskCallBack){
	var jsonText = JsonObjectToString(dataJson);
    Bridge.callByNotify(_bgLocationUtil_queryTaskCallBack,queryTaskCallBack,null,null,null,"s_BgLocationUtil_queryTask", jsonText, null, null,null,null,null,null);
};
function _bgLocationUtil_queryTaskCallBack(id,resultCode, taskId){
    //Log.i("Webkit", "bridgeclient is _bgLocationUtil_queryTaskCallBack, resultCode=" + resultCode
         // + ", taskId=" + taskId + ",  callId=" + id);
    //获取回调对象
    var callback = Bridge.callbacks[id];
    if(callback.usercallback1)
    {
        callback.usercallback1(resultCode, taskId);
    }
}

/*3*/
BgLocationUtil.getTask = function(){
    var jsonText = Bridge.callRetStr('s_BgLocationUtil_getTask',null, null, null,null,null,null,null);
    if("null" == jsonText)
    {
        return null;
    }
    else
    {
        return ExmobiJSON.parse(jsonText);
    }
}
/*4*/
BgLocationUtil.getLogPath = function(){
	var res = Bridge.callRetStr('s_BgLocationUtil_getLogPath',null, null, null,null,null,null,null);
    return jsonStringToArray(res);
}
/*5*/
BgLocationUtil.uploadLocationData = function(uploadDataCallBack)
{
    Bridge.callByNotify(_bgLocationUtil_uploadLocationDataCallBack,uploadDataCallBack,null,null,null,"s_BgLocationUtil_uploadLocationData", null, null, null,null,null,null,null);
}
function _bgLocationUtil_uploadLocationDataCallBack(id,resultcode){
    //Log.i("Webkit", "bridgeclient is _bgLocationUtil_uploadLocationDataCallBack, resultcode=" + resultcode
         // + ",  callId=" + id);
    //获取回调对象
    var callback = Bridge.callbacks[id];
    if(callback.usercallback1)
    {
        callback.usercallback1(resultcode);
    }
}

/*6*/
BgLocationUtil.immediateLocation = function(taskId, immediateLocationCallBack){
    Bridge.callByNotify(_bgLocationUtil_immediateLocationCallBack,immediateLocationCallBack,null,null,null,"s_BgLocationUtil_immediateLocation", taskId, null, null,null,null,null,null);
}
function _bgLocationUtil_immediateLocationCallBack(id,locationResultCode, updateResultCode){
    //Log.i("Webkit", "bridgeclient is _bgLocationUtil_immediateLocationCallBack, locationResultCode=" + locationResultCode
         // + ",  updateResultCode=" + updateResultCode+ ",  callId=" + id);
    //获取回调对象
    var callback = Bridge.callbacks[id];
    if(callback.usercallback1)
    {
        callback.usercallback1(locationResultCode, updateResultCode);
    }
}

/*7*/
BgLocationUtil.setConfig = function(configJson){
    var jsonText = JsonObjectToString(configJson);
	return stringToBool(Bridge.callRetStr('s_BgLocationUtil_setConfig',jsonText, null, null,null,null,null,null));
}


//百度通知
var BaiduPushUtil = {};
BaiduPushUtil.startWork = function(onBindFunction)
{
    Bridge.callByNotify(_BaiduPushUtil_usualCallBack,onBindFunction,null,null,this,"s_BaiduPushUtil_startWork",null, null, null, null, null,null,null);
}

BaiduPushUtil.stopWork = function(onUnBindFunction)
{
    Bridge.callByNotify(_BaiduPushUtil_usualCallBack,onUnBindFunction,null,null,this,"s_BaiduPushUtil_stopWork",null, null, null, null, null,null,null);
}

BaiduPushUtil.isPushEnabled = function(isPushEnabled)
{
    return true;
}

BaiduPushUtil.setTags = function(arrayTags, onSetTagsFun)
{
    var text = arrayToJsonString(arrayTags);
    Bridge.callByNotify(_BaiduPushUtil_usualCallBack,onSetTagsFun,null,null,this,"s_BaiduPushUtil_setTags",text, null, null, null, null,null,null);
}

BaiduPushUtil.delTags = function(arrayTags, onDelTagsFun)
{
    var text = arrayToJsonString(arrayTags);
    Bridge.callByNotify(_BaiduPushUtil_usualCallBack,onDelTagsFun,null,null,this,"s_BaiduPushUtil_delTags",text, null, null, null, null,null,null);
}

BaiduPushUtil.listTags = function(onListTagsFun)
{
    Bridge.callByNotify(_BaiduPushUtil_usualCallBack,onListTagsFun,null,null,this,"s_BaiduPushUtil_listTags",null, null, null, null, null,null,null);
}

BaiduPushUtil.enableDebugMode = function(debugEnabled)
{
    
}

BaiduPushUtil.getAppId = function()
{
    var text = Bridge.callRetStr('s_BaiduPushUtil_getAppId' ,null, null, null, null, null,null,null);
    return text;
}

BaiduPushUtil.getChannelId = function()
{
    var text = Bridge.callRetStr('s_BaiduPushUtil_getChannelId' ,null, null, null, null, null,null,null);
    return text;
}

BaiduPushUtil.getUserId = function()
{
    var text = Bridge.callRetStr('s_BaiduPushUtil_getUserId' ,null, null, null, null, null,null,null);
    return text;
}


function _BaiduPushUtil_usualCallBack(id, jsonStr)
{
    var callback = Bridge.callbacks[id];
    var json = ExmobiJSON.parse(jsonStr);
    if(callback.usercallback1)
    {
        callback.usercallback1(json);
    }
}


//SensorUtil
var SensorUtil = {};
SensorUtil.isSupportAccelerometer = function()
{
   var text = Bridge.callRetStr('s_SensorUtil_isSupportAccelerometer' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.openAccelerometer = function(rate,callback)
{
   Bridge.callByNotify(_SensorUtil_CallBack,callback,null,null,this,"s_SensorUtil_openAccelerometer",rate, null, null, null, null,null,null);
}
SensorUtil.isOpenAccelerometer = function()
{
   var text = Bridge.callRetStr('s_SensorUtil_isOpenAccelerometer' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.closeAccelerometer = function()
{
   Bridge.callRetStr('s_SensorUtil_closeAccelerometer' ,null, null, null, null, null,null,null);  
}
SensorUtil.isSupportOrientation = function()
{
   var text = Bridge.callRetStr('s_SensorUtil_isSupportOrientation' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

SensorUtil.openOrientation = function(rate,callback)
{
   Bridge.callByNotify(_SensorUtil_CallBack,callback,null,null,this,"s_SensorUtil_openOrientation",rate, null, null, null, null,null,null);
}

SensorUtil.isOpenOrientation = function()
{
   var text = Bridge.callRetStr('s_SensorUtil_isOpenOrientation' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

SensorUtil.closeOrientation = function()
{
   Bridge.callRetStr('s_SensorUtil_closeOrientation' ,null, null, null, null, null,null,null);   
}

SensorUtil.isSupportMagnetic = function()
{
  var text = Bridge.callRetStr('s_SensorUtil_isSupportMagnetic' ,null, null, null, null, null,null,null);
   return stringToBool(text); 
}
SensorUtil.openMagnetic = function(rate,callback)
{
   Bridge.callByNotify(_SensorUtil_CallBack,callback,null,null,this,"s_SensorUtil_openMagnetic",rate, null, null, null, null,null,null);
}
SensorUtil.isOpenMagnetic = function()
{
    var text = Bridge.callRetStr('s_SensorUtil_isOpenMagnetic' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.closeMagnetic = function()
{
   Bridge.callRetStr('s_SensorUtil_closeMagnetic' ,null, null, null, null, null,null,null);   
}
SensorUtil.isSupportLight = function()
{
    var text = Bridge.callRetStr('s_SensorUtil_isSupportLight' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.openLight = function(rate,callback)
{
   Bridge.callByNotify(_SensorUtil_LightCallBack,callback,null,null,this,"s_SensorUtil_openLight",rate, null, null, null, null,null,null);
}

SensorUtil.isOpenLight = function()
{
    var text = Bridge.callRetStr('s_SensorUtil_isOpenLight' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.closeLight = function()
{
   Bridge.callRetStr('s_SensorUtil_closeLight' ,null, null, null, null, null,null,null);   
}
SensorUtil.isSupportGyro = function()
{
    var text = Bridge.callRetStr('s_SensorUtil_isSupportGyro' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

SensorUtil.openGyro = function(rate,callback)
{
   Bridge.callByNotify(_SensorUtil_CallBack,callback,null,null,this,"s_SensorUtil_openGyro",rate, null, null, null, null,null,null);
}
SensorUtil.isOpenGyro = function()
{
    var text = Bridge.callRetStr('s_SensorUtil_isOpenGyro' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
SensorUtil.closeGyro = function()
{
   Bridge.callRetStr('s_SensorUtil_closeGyro' ,null, null, null, null, null,null,null);   
}



function _SensorUtil_LightCallBack(id,lightChange)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        callback.usercallback1(lightChange);
    }
}


function _SensorUtil_CallBack(id,x,y,z)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        callback.usercallback1(x,y,z);
    }
}


//AlipayUtil
var AlipayUtil = {};
AlipayUtil.pay = function(payJson,successCallBack,failCallBack)
{
	var text = JsonObjectToString(payJson);
	Bridge.callByNotify(_AlipayUtil_SuccessCallBack,successCallBack,_AlipayUtil_FailCallBack,failCallBack,this,"s_AlipayUtil_pay",text, null, null, null, null,null,null);    
}

function _AlipayUtil_SuccessCallBack(id,text)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
    		var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}
function _AlipayUtil_FailCallBack(id,code,text)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback2)
    {
    	  var json = ExmobiJSON.parse(text);
        callback.usercallback2(code,json);
    }
}
//UppayUtil
var UppayUtil = {};
UppayUtil.pay = function(payJson,successCallBack,failCallBack)
{
	var text = JsonObjectToString(payJson);
	Bridge.callByNotify(_UppayUtil_SuccessCallBack,successCallBack,_UppayUtil_FailCallBack,failCallBack,this,"s_UppayUtil_pay",text, null, null, null, null,null,null);    
}

function _UppayUtil_SuccessCallBack(id,text)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
    		var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}
function _UppayUtil_FailCallBack(id,code,text)
{		
	  var callback = Bridge.callbacks[id];   
    if(callback.usercallback2)
    {
    	  var json = ExmobiJSON.parse(text);
        callback.usercallback2(code,json);
    }
}

function stringToBool(text)
{
	 if(text.toLowerCase() == "true" )
	 {
	 	 return true;
	 }
	 else
	 {
	 	 return false;
	 }
}

function stringToInt(text)
{
	 return parseInt(text);
}
function stringToDouble(text)
{
	 return parseFloat(text);
}

function arrayToJsonString(array)
{
		var text = "[";	 	
		var len = array.length;  
 	  for(var i = 0; i < len;i = i + 1)
 	  {
 	  	 text = text + '{\"value\":\"' + array[i] + '\"}';
 	  	 if(i != len - 1)
 	  	 {
 	  	 	  text = text + ",";
 	  	 }
 	  }	 	  
	 	text = text + "]";
	 	return text;
}
function jsonStringToArray(json)
{
	var json = ExmobiJSON.parse(json);
	 var array = new Array();
	 for(var i = 0; i < json.length;i++)
	 {
	 	  var v = json[i].value;	 	 
	 	  array.push(v);	 	  
	 }
	 return array;
}

var loadXML = function(xmlString)
{
        var xmlDoc=null;
        //判断浏览器的类型
        //支持IE浏览器 
        if(!window.DOMParser && window.ActiveXObject){   //window.DOMParser 判断是否是非ie浏览器
            var xmlDomVersions = ['MSXML.2.DOMDocument.6.0','MSXML.2.DOMDocument.3.0','Microsoft.XMLDOM'];
            for(var i=0;i<xmlDomVersions.length;i++){
                try{
                    xmlDoc = new ActiveXObject(xmlDomVersions[i]);
                    xmlDoc.async = false;
                    xmlDoc.loadXML(xmlString); //loadXML方法载入xml字符串
                    break;
                }catch(e){
                }
            }
        }
        //支持Mozilla浏览器
        else if(window.DOMParser && document.implementation && document.implementation.createDocument)
        {        		
            try
            {
                /* DOMParser 对象解析 XML 文本并返回一个 XML Document 对象。
                 * 要使用 DOMParser，使用不带参数的构造函数来实例化它，然后调用其 parseFromString() 方法
                 * parseFromString(text, contentType) 参数text:要解析的 XML 标记 参数contentType文本的内容类型
                 * 可能是 "text/xml" 、"application/xml" 或 "application/xhtml+xml" 中的一个。注意，不支持 "text/html"。
                 */               
                domParser = new  DOMParser();
                xmlDoc = domParser.parseFromString(xmlString, 'text/xml');                
            }
            catch(e)
            {
            	
            }
        }
        else
        {
            return null;
        }

        return xmlDoc;
}

 

function JsonObjectToString(o)
{	
	var r = [];   
	if(typeof o =="string") return "\""+o.replace(/([\'\"\\])/g,"\\$1").replace(/(\n)/g,"\\n").replace(/(\r)/g,"\\r").replace(/(\t)/g,"\\t")+"\"";
  if(typeof o == "number") return "\"" + o + "\"";
 	if(typeof o == "boolean") return "\"" + o + "\"";
	if(typeof o =="undefined") return "";
	if(typeof o != "object") return o.toString();
	if(o===null) return null;
  if(o instanceof Array)
  {
     for(var i =0;i<o.length;i++)
     {
        r.push(this.JsonObjectToString(o[i]));
     }
     r="["+r.join()+"]"; 
  }
  else
  {              
     for(var i in o)
     {     	
        r.push('"'+i+'":'+this.JsonObjectToString(o[i]));
     }
     r="{"+r.join()+"}";
  }   
  return r; 
}

//ImUtil
var ImUtil = {};
ImUtil.setSettingInfo = function(jsonData)
{
    var text = JsonObjectToString(jsonData);
	Bridge.callRetStr('s_ImUtil_setSettingInfo',text, null, null, null, null,null,null);
}

ImUtil.login = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_ImUtil_callBackFun,callBackFun,null,null,this,"s_ImUtil_login",text, null, null, null, null,null,null);    
}

ImUtil.refreshImData = function(callBackFun)
{
	Bridge.callByNotify(_ImUtil_refreshImData_callBackFun,callBackFun,null,null,this,"s_ImUtil_refreshImData",null, null, null, null, null,null,null);    
}

ImUtil.getAccount = function()
{
	var text = Bridge.callRetStr('s_ImUtil_getAccount',null,null,null, null, null,null,null);
	 var json = ExmobiJSON.parse(text);
	 return json; 		   
}

ImUtil.logout = function()
{
    Bridge.callRetStr('s_ImUtil_logout',null,null,null, null, null,null,null);		   
}

ImUtil.startChatRoom = function(jsonData)
{
    var text = JsonObjectToString(jsonData);
	Bridge.callRetStr('s_ImUtil_startChatRoom',text, null, null, null, null,null,null);	   
}

function _ImUtil_refreshImData_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        callback.usercallback1(text);
    }
}

function _ImUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}

//DecodeUtil
var DecodeUtil = {};
DecodeUtil.scan = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_DecodeUtil_callBackFun,callBackFun,null,null,this,"s_DecodeUtil_scan",text, null, null, null, null,null,null);    
}

function _DecodeUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}

//QqUtil
var QqUtil = {};
QqUtil.isQQInstalled = function()
{
   var text = Bridge.callRetStr('s_QqUtil_isQQInstalled' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

QqUtil.isLogin = function()
{
   var text = Bridge.callRetStr('s_QqUtil_isLogin' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

QqUtil.logout = function()
{
   Bridge.callRetStr('s_QqUtil_logout' ,null, null, null, null, null,null,null);
}

QqUtil.login = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_QqUtil_callBackFun,callBackFun,null,null,this,"s_QqUtil_login",text, null, null, null, null,null,null);    
}

QqUtil.getUserInfo = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_QqUtil_callBackFun,callBackFun,null,null,this,"s_QqUtil_getUserInfo",text, null, null, null, null,null,null);    
}

QqUtil.shareImage = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_QqUtil_callBackFun,callBackFun,null,null,this,"s_QqUtil_shareImage",text, null, null, null, null,null,null);    
}

QqUtil.shareNews = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_QqUtil_callBackFun,callBackFun,null,null,this,"s_QqUtil_shareNews",text, null, null, null, null,null,null);    
}

QqUtil.shareMusic = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_QqUtil_callBackFun,callBackFun,null,null,this,"s_QqUtil_shareMusic",text, null, null, null, null,null,null);    
}

function _QqUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}


//BaiduVoiceUtil
var BaiduVoiceUtil = {};
BaiduVoiceUtil.record = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_BaiduVoiceUtil_callBackFun,callBackFun,null,null,this,"s_BaiduVoiceUtil_record",text, null, null, null, null,null,null);    
}
function _BaiduVoiceUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}

//BaiduTtsUtil
var BaiduTtsUtil ={};
BaiduTtsUtil.play = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_BaiduPlayUtil_callBackFun,callBackFun,null,null,this,"s_BaiduTtsUtil_play",text, null, null, null, null,null,null);    
}
function _BaiduPlayUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}


//WeixinUtil
var WeixinUtil = {};
WeixinUtil.isWeixinInstalled = function()
{
   var text = Bridge.callRetStr('s_WeixinUtil_isWeixinInstalled' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

WeixinUtil.isSupportPay = function()
{
   var text = Bridge.callRetStr('s_WeixinUtil_isSupportPay' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}

WeixinUtil.shareText = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_shareText",text, null, null, null, null,null,null);    
}
WeixinUtil.shareImage = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_shareImage",text, null, null, null, null,null,null);    
}
WeixinUtil.shareNews = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_shareNews",text, null, null, null, null,null,null);    
}
WeixinUtil.getAuthCode = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_getAuthCode",text, null, null, null, null,null,null);    
}

WeixinUtil.getAccessToken = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_getAccessToken",text, null, null, null, null,null,null);    
}

WeixinUtil.authAccessToken = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_authAccessToken",text, null, null, null, null,null,null);    
}

WeixinUtil.refreshAccessToken = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_refreshAccessToken",text, null, null, null, null,null,null);    
}
WeixinUtil.getUserInfo = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_getUserInfo",text, null, null, null, null,null,null);    
}
WeixinUtil.payOrder = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_WeixinUtil_callBackFun,callBackFun,null,null,this,"s_WeixinUtil_payOrder",text, null, null, null, null,null,null);    
}
function _WeixinUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}

//XhsUaaManager
var XhsUaaManager = {};
XhsUaaManager.setConfig = function(jsonData)
{
    var text = JsonObjectToString(jsonData);
	Bridge.callRetStr('s_XhsUaaManager_setConfig',text, null, null, null, null,null,null);
}
XhsUaaManager.setUserName = function(userName)
{
	Bridge.callRetStr('s_XhsUaaManager_setUserName',userName, null, null, null, null,null,null);
}
XhsUaaManager.setUserId = function(userId)
{
	Bridge.callRetStr('s_XhsUaaManager_setUserId',userId, null, null, null, null,null,null);
}
XhsUaaManager.setSessionContinueMillis = function(interval)
{
	Bridge.callRetStr('s_XhsUaaManager_setSessionContinueMillis',interval, null, null, null, null,null,null);
}
XhsUaaManager.onResume = function()
{
	Bridge.callRetStr('s_XhsUaaManager_onResume',null, null, null, null, null,null,null);
}
XhsUaaManager.onPause = function()
{
	Bridge.callRetStr('s_XhsUaaManager_onPause',null, null, null, null, null,null,null);
}
XhsUaaManager.onEvent = function(jsonData)
{
    var text = JsonObjectToString(jsonData);
	Bridge.callRetStr('s_XhsUaaManager_onEvent',text, null, null, null, null,null,null);
}

//TouchIdUtil
var TouchIdUtil = {};
TouchIdUtil.isSupportTouch = function()
{
   var text = Bridge.callRetStr('s_TouchIdUtil_isSupportTouch' ,null, null, null, null, null,null,null);
   return stringToBool(text);
}
TouchIdUtil.verify = function(jsonData,callBackFun)
{
	var text = JsonObjectToString(jsonData);
	Bridge.callByNotify(_TouchIdUtil_callBackFun,callBackFun,null,null,this,"s_TouchIdUtil_verify",text, null, null, null, null,null,null);    
}
function _TouchIdUtil_callBackFun(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
        var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}


//HwIdCardUtil
var HwCardUtil = {};
HwCardUtil.discernIdCard = function(json,callback)
{
    var text = JsonObjectToString(json);
    Bridge.callByNotify(_HwCardUtil_CallBack,callback,null,null,this,"s_HwCardUtil_discernIdCard",text, null, null, null, null,null,null);  	
}

HwCardUtil.discernBCard = function(json,callback)
{
    var text = JsonObjectToString(json);
    Bridge.callByNotify(_HwCardUtil_CallBack,callback,null,null,this,"s_HwCardUtil_discernBCard",text, null, null, null, null,null,null);  	
}

function _HwCardUtil_CallBack(id,text)
{		
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
    	var json = ExmobiJSON.parse(text);
        callback.usercallback1(json);
    }
}

//百度地图
var BaidumapUtil = {};
BaidumapUtil.importOfflineData = function(json,callback)
{	
    var text = JsonObjectToString(json);
    Bridge.callByNotify(_Json_CallBack,callback,null,null,this,"s_BaidumapUtil_importOfflineData",text, null, null, null, null,null,null);	
}
BaidumapUtil.coordinateConverter = function(json)
{
    var text = JsonObjectToString(json);
    text = Bridge.callRetStr('s_BaidumapUtil_coordinateConverter',text, null, null, null, null,null,null); 	
    return JSON.parse(text);  	
}
BaidumapUtil.getDistance = function(startJson,endJson)
{
    var text1 = JsonObjectToString(startJson);
	var text2 = JsonObjectToString(endJson);
    var text = Bridge.callRetStr('s_BaidumapUtil_getDistance',null, null, null, null, null,null,null);
	return stringToDouble(text);
}
BaidumapUtil.reverseGeocode = function(json,callback)
{
    var text = JsonObjectToString(json);
    Bridge.callByNotify(_BaidumapUtil_CallBack,callback,null,null,this,"s_BaidumapUtil_reverseGeocode",text, null, null, null, null,null,null);	
}
BaidumapUtil.geocode = function(json,callback)
{
    var text = JsonObjectToString(json);
    Bridge.callByNotify(_BaidumapUtil_CallBack,callback,null,null,this,"s_BaidumapUtil_geocode",text, null, null, null, null,null,null);	
}
function _BaidumapUtil_CallBack(id,code,text)
{	
	var callback = Bridge.callbacks[id];   
    if(callback.usercallback1)
    {
    	var json = JSON.parse(text);
		var retCode = stringToInt(code);
        callback.usercallback1(code,json);
    }
}

//TcpSocket
var TcpSocket = function(json)
{	     
	var text = JsonObjectToString(json);		
	this.objName = "tcpsocket";
	this.connectFunction = null;
	this.sendFunction = null;
	this.receiveFunction = null;
	this.disconnectFunction = null;
    this.id= webkitobjectid++;
	this.jsonText = text;
	
	
	
	if(typeof json.connectFunction == "string")	
		this.connectFunction = eval(json.connectFunction);				
	if(typeof json.sendFunction == "string")	
		this.sendFunction = eval(json.sendFunction);	
	if(typeof json.receiveFunction == "string")	
		this.receiveFunction = eval(json.receiveFunction);	
	if(typeof json.disconnectFunction == "string")	
		this.disconnectFunction = eval(json.disconnectFunction);		
		
   
   this.connect = function()
    {   	  
      Bridge.callByNotify(_TcpSocket_onSuccessCallback,null,null,null,this,'s_TcpSocket_connect' ,this.jsonText, this.id, null, null, null,null,null);
    };
    this.send = function(data)
    {   
		Bridge.callRetStr('s_TcpSocket_send',data, this.id, null, null, null,null,null);    
    };  
    this.disconnect = function()
    {   
		Bridge.callRetStr('s_TcpSocket_disconnect',this.id, null, null, null, null,null,null);    
    }; 	
}
function _TcpSocket_onSuccessCallback(id,type,jsonText)
{	
    var callback =  Bridge.callbacks[id];
    if (callback.object == null)
    {
        return;
    }
    else
    {
    	var json = JSON.parse(jsonText);
		if(type == 0 && callback.object.connectFunction != null)
			callback.object.connectFunction(json);
		if(type == 1 && callback.object.sendFunction != null)
			callback.object.sendFunction(json);
		if(type == 2 && callback.object.receiveFunction != null)
			callback.object.receiveFunction(json);
		if(type == 3 && callback.object.disconnectFunction != null)
			callback.object.disconnectFunction(json);
    }
}

//Console
var console = {};
console.log = function(data)
{
  Bridge.callRetStr('s_console_log',data, null, null, null, null,null,null);  
}
console.debug = function(data)
{
  Bridge.callRetStr('s_console_debug',data, null, null, null, null,null,null);  
}
console.info = function(data)
{
  Bridge.callRetStr('s_console_info',data, null, null, null, null,null,null);  
}
console.warn = function(data)
{
  Bridge.callRetStr('s_console_warn',data, null, null, null, null,null,null);  
}
console.error = function(data)
{
  Bridge.callRetStr('s_console_error',data, null, null, null, null,null,null);  
}

//ImageUtil
ImageUtil = {};
ImageUtil.scale = function(json)
{
    var text = JsonObjectToString(json);
    text = Bridge.callRetStr('s_ImageUtil_scale',text, null, null, null, null,null,null); 	
    return stringToBool(text);
}
ImageUtil.scaleByRate = function(json)
{
    var text = JsonObjectToString(json);
    text = Bridge.callRetStr('s_ImageUtil_scaleByRate',text, null, null, null, null,null,null); 	
    return stringToBool(text);
}
ImageUtil.scaleByFileSize = function(json)
{
    var text = JsonObjectToString(json);
    text = Bridge.callRetStr('s_ImageUtil_scaleByFileSize',text, null, null, null, null,null,null); 	
    return stringToBool(text);
}


